      PROGRAM RASC                                                      10
C                                                                       20
C                                                                       30
C                                                                       40
C                    RRRR      A      SSS     CCC                       50
C                    R   R    A A    S   S   C   C                      60
C                    R   R   A   A   S       C                          70
C                    RRRR    AAAAA    SSS    C                          80
C                    R R     A   A       S   C                          90
C                    R  R    A   A   S   S   C   C                      100
C                    R   R   A   A    SSS     CCC                       110
C                                                                       120
C                                                                       130
C                                                                       140
C                                                                       150
C                     F.P. AGTERBERG AND L.D. NEL                       160
C                            JANUARY 1981                               170
C                                                                       180
C                       WITH LATER REVISIONS BY                         190
C               F.P. AGTERBERG, S.N. LEW, AND M. HELLER                 200
C                                                                       210
C                                                                       220
C                       TO ACCOMPANY GSC REPORT                         230
C             "RASC FORTRAN 77 COMPUTER PROGRAM FOR RANKING             240
C              AND SCALING OF BIOSTRATIGRAPHIC EVENTS"                  250
C                                                                       260
C              M. HELLER, W.S. GRADSTEIN, F.M. GRADSTEIN,               270
C                     F.P. AGTERBERG, AND S.N. LEW                      280
C                                                                       290
C                          SEPTEMBER 1985                               300
C                                                                       310
C                     GEOLOGICAL SURVEY OF CANADA                       320
C                          601 BOOTH STREET                             330
C                          OTTAWA, ONTARIO                              340
C                               K1A 0E8                                 350
C                                                                       360
C                       CROWN COPYRIGHT RESERVED                        370
C                                                                       380
C                                                                       390
C                                                                       400
C                 PROGRAM RASC IS A REVISED VERSION OF THE              410
C             PROGRAMS SEQONE AND SEQTWO PRESENTED DURING               420
C             THE IGCP PROJECT 148 WORKSHOPS IN DARTMOUTH, N.S.,        430
C             AUGUST 1979, AND OTTAWA, FEBRUARY 1980.                   440
C                                                                       450
C                 THE JANUARY 1981 RASC PROGRAM WAS PUBLISHED           460
C             IN 1982 IN "COMPUTERS AND GEOSCIENCES", VOL.8             470
C             NO.1, PP.69-90, AND VOL.8, NO.1, PP.163-189.              480
C                 A REVISED VERSION OF IT WAS PUBLISHED IN              490
C             APRIL 1983 AS GEOLOGICAL SURVEY OF CANADA,                500
C             OPEN FILE NO. 922, WITH A 54-PAGE USER'S MANUAL           510
C             BY M. HELLER, W.S. GRADSTEIN, F.M. GRADSTEIN,             520
C             AND F.P. AGTERBERG.                                       530
C                 THIS OPEN FILE RASC PROGRAM WAS AGAIN                 540
C             MODIFIED BEFORE PRESENTATIONS DURING THE IGCP             550
C             PROJECT 148 SHORT COURSE IN DARTMOUTH, N.S.,              560
C             OCTOBER 1983.  IT SERVED AS A BASIS OF THE FORTRAN        570
C             IV PROGRAM RASC-C FOR PREPARATION OF CASC INPUT.          580
C             (SEE OPEN FILE NO. 1179, SEPTEMBER 1985)                  590
C                                                                       600
C                 THE PRESENT VERSION, WHICH ACCOMPANIES A NEW          610
C             RASC USER'S MANUAL, CONTAINS FURTHER REVISIONS            620
C             BY S.N. LEW AND COMPLIES WITH THE ANSI FORTRAN 77         630
C             STANDARD.                                                 640
C                                                                       650
C                                                                       660
C                                                                       670
C               PROGRAM INPUTS                                          680
C               --------------                                          690
C                                                                       700
C                                                                       710
C                                                                       720
C     RECORD NO. 1     RUN PARAMETERS     (FREE FORMAT)                 730
C     ------------     --------------                                   740
C                                                                       750
C   NS     -  (INTEGER)   NUMBER OR SEQUENCES OR WELLS  (NS <= 25)      760
C   IOCR   -  (INTEGER)   ELEMENTS OCCURRING FEWER THAN "IOCR" TIMES IN 770
C                             THE DATA SET WILL BE IGNORED              780
C   INIQ   -  (INTEGER)   = 1, IF UNIQUE EVENTS OR MARKER HORIZONS ARE  790
C                                   INCLUDED  (RECORDS 3 AND 4)         800
C   ITER   -  (INTEGER)   MAXIMUM NUMBER OF CUMULATIVE ORDER MATRIX     810
C                             TRANSFORMATIONS ALLOWED  (EXAMPLE: 12000) 820
C   CRIT1  -  (REAL)      TRANSPOSE ELEMENTS WITH SUM LESS THAN "CRIT1" 830
C                             IN THE ORDER MATRIX WILL BE ZEROED BEFORE 840
C                             THE RANKING SOLUTION.  (CRIT1 <= IOCR)    850
C   TOL    -  (REAL)      TOLERANCE:  S(I,J) MAY BE LOWER THAN S(J,I)   860
C                                     BY AS MUCH AS "TOL"               870
C   AAA    -  (REAL)      FRACTILE FOR TRUNCATION POINT OF NORMAL       880
C                             DISTRIBUTION.  (EXAMPLE: AAA = 1.645)     890
C   CRIT2  -  (REAL)      TRANSPOSE ELEMENTS WITH SUM LESS THAN "CRIT2" 900
C                             IN THE ORDER MATRIX WILL BE ZEROED BEFORE 910
C                             THE SCALING ANALYSIS.  (CRIT2 >= CRIT1)   920
C                                                                       930
C                                                                       940
C     RECORD NO. 2     PROCESSING CONTROL       (FREE FORMAT)           950
C     ------------     ------------------                               960
C                                                                       970
C  ALL 12 PARAMETERS ON THIS RECORD ARE INTEGERS.                       980
C  FOR SHORT VERSION OF RASC (RANKING ALGORITHMS ONLY), IALPHA=0        990
C                                                                       1000
C                                                                       1010
C   ITAPE     = 1   FOR DATA TO BE READ FROM "TAPE10"                   1020
C              ELSE,       DATA WILL BE READ FROM RECORDS IMMEDIATELY   1030
C                          FOLLOWING RECORD NO. 4                       1040
C   IOMAT     = 1   FOR PRINTOUT OF ORDER AND FREQUENCY MATRICES        1050
C                     AS WELL AS INTERMEDIATE TABLES;                   1060
C              ELSE,       THESE OUTPUTS WILL BE SUPPRESSED             1070
C   ISRT      = 1,  DATA WILL BE PRE-SEQUENCED FOR OPTIMIZED STARTING   1080
C                      SEQUENCE                                         1090
C   IALPHA    = 0,  TERMINATION AFTER RANKING SOLUTION;                 1100
C             = 1,  SCALING ANALYSIS WILL BE DONE;                      1110
C              ELSE,       TERMINATION AFTER RANKING SOLUTION, BUT      1120
C                          STEPWISE SEQUENCING PROGRESS WILL BE         1130
C                          PRINTED BEFORE TERMINATION.                  1140
C   ITAB1     = 1,  AN OCCURRENCE TABLE FOR THE WELLS IS TO BE PRINTED  1150
C              ELSE,       NO TABLE.                                    1160
C   ISCORE    = 1,  STEP MODEL COMPARISON OF INDIVIDUAL WELLS AND       1170
C                       FOSSILS WITH OPTIMUM SEQUENCE IS PERFORMED      1180
C   ICOMP     = 1   FOR NORMALITY TESTS ON INDIVIDUAL WELLS             1190
C   ISKIP     = 1   IF CUMULATIVE ORDER MATRIX IS TO BE USED            1200
C                    (RANKING SOLUTION WILL BE BASED ON PRESORTING      1210
C                     ONLY)                                             1220
C              ELSE,       RASC WILL GO AHEAD AND PERFORM MATRIX        1230
C                          PERMUTATIONS.                                1240
C   IFIN      = 1   FOR APPLICATION OF FINAL RE-ORDERING                1250
C   INOSC     = 0,  NO SCALING OUTPUT;                                  1260
C             = 1,  WEIGHTED DISTANCE OUTPUT ONLY;                      1270
C              ELSE,       WEIGHTED AND UNWEIGHTED OUTPUT.              1280
C   INEG      = 1,  LARGE DISTANCES FOR SMALL SAMPLES WILL BE SUPPRESSED1290
C              ELSE,       NO SUPPRESSION.                              1300
C   ISCAT     = 1,  SCATTERGRAMS ARE TO BE PRINTED FOR EACH WELL.       1310
C              ELSE,       NO SCATTERGRAMS PRINTED                      1320
C                                                                       1330
C                                                                       1340
C     RECORD NO. 3     UNIQUE EVENTS                                    1350
C     ------------     -------------                                    1360
C                                                                       1370
C     IF INIQ = 1, UP TO 20 UNIQUE EVENTS WILL BE READ FROM THIS        1380
C     RECORD IN 20I4 FORMAT.  IF NO UNIQUE EVENTS ARE REQUESTED,        1390
C     THIS RECORD IS LEFT BLANK.  IF UNIQUE EVENTS ARE INCLUDED,        1400
C     "ICOMP" MUST EQUAL 1.                                             1410
C                                                                       1420
C                                                                       1430
C     RECORD NO. 4     MARKER HORIZONS                                  1440
C     ------------     ---------------                                  1450
C                                                                       1460
C     IF INIQ = 1, UP TO 20 MARKER HORIZONS WILL BE READ FROM           1470
C     THIS RECORD IN 20I4 FORMAT.  IF NO MARKER HORIZONS ARE            1480
C     REQUESTED, THIS RECORD IS LEFT BLANK.                             1490
C                                                                       1500
C                                                                       1510
C                                                                       1520
C     DATA SET              (SEMI-FREE FORMAT)                          1530
C     --------                                                          1540
C                                                                       1550
C     OBSERVED EVENTS:      THE OBSERVED DATA ARE GIVEN AS "NS"         1560
C                           SEQUENCES.  A "SEQUENCE" CONSISTS OF        1570
C            A TITLE RECORD (IN 5A4 FORMAT) FOLLOWED BY ONE OR MORE     1580
C            RECORDS OF SEQUENCE DATA (IN MULTIPLE I4 FORMAT).          1590
C                EACH OF THESE DATA RECORDS IS PARTITIONED INTO 20      1600
C            FIELDS, EACH FIELD HAVING I4 FORMAT.  THUS, THERE          1610
C            MAY BE UP TO 20 EVENTS ON ONE RECORD.                      1620
C                NOTE:   FIELDS NEED NOT BE FILLED CONSECUTIVELY.       1630
C                        EMPTY FIELDS ARE IGNORED.                      1640
C                                                                       1650
C                A SEQUENCE IS DEEMED TO HAVE ENDED WHEN A FIELD        1660
C            CONTAINING   -999   IS ENCOUNTERED.                        1670
C                THE SEQUENCES ARE READ EITHER FROM "TAPE10"            1680
C            (IF ITAPE = 1) OR FROM RECORDS IMMEDIATELY FOLLOWING       1690
C            RECORD NUMBER 4  (IF ITAPE = 0).                           1700
C                                                                       1710
C                                                                       1720
C     DICTIONARY:           THE DICTIONARY IS MERELY A LIST OF          1730
C                           EVENT LABELS:  ONE LABEL PER RECORD,        1740
C            10A4 FORMAT.  AN EXTRA RECORD WITH THE LABEL 'LAST'        1750
C            IN THE FIRST 4 COLUMNS MUST BE PLACED AT THE END.          1760
C            LIMIT:  280 RECORDS  (NOT COUNTING 'LAST' RECORD)          1770
C            THE DICTIONARY IS ALWAYS READ FROM "TAPE99".               1780
C                                                                       1790
C  ---------------------------------------------------------------------1800
C                                                                       1810
      PARAMETER (KDIM1=25, KDIM3=120, KDIM4=280, KDIM5=10, KDIM6=145)   1820
      PARAMETER (MAXCYC=300, MAXUQ=20)                                  1830
C                                                                       1840
      COMMON N, NS, MMAX, IX(KDIM1,KDIM3), ICODE(KDIM4), IRCODE(KDIM4), 1850
     +        C(KDIM6,KDIM6)                                            1860
      COMMON  /BETA/ IUNIQ(KDIM4,2), NUNIQ(KDIM1), MUNIQ(KDIM1,MAXUQ*2) 1870
      COMMON  /DELTA/ IOCR, INIQ, CRIT1, TOL, AAA, CRIT2, MAX, ITER,    1880
     +        IOMAT, ISRT, IALPHA, ITAB1, ISCORE, ICOMP, ISKIP, IFIN,   1890
     +        INOSC, INEG, ISCAT, TMAT(KDIM1,KDIM3)                     1900
      COMMON  /TEXT/ NAME(KDIM1,5), ITITLE(KDIM4,10)                    1910
      INTEGER AA, AID, COUNT, T, TEST, IPOS(KDIM6), IQD(KDIM3),         1920
     +        IRANGE(KDIM6,2), JIRCOD(KDIM6), IPAIR(2,KDIM6+MAXUQ),     1930
     +        MPAIR(KDIM6+MAXUQ), TMAT                                  1940
      REAL    A(300), B(300), CC(600), QDAR(KDIM6+MAXUQ), WVEC(KDIM5),  1950
     +        XLEV(KDIM6+MAXUQ)                                         1960
      CHARACTER*4   NAME, ITITLE                                        1970
C                                                                       1980
C  EXPLANATION OF CONSTANTS IN THE PARAMETER LIST                       1990
C                                                                       2000
C  KDIM1  - MAXIMUM NUMBER OF WELLS (SECTIONS)                          2010
C  KDIM3  - MAXIMUM LENGTH OF ANY ONE WELL                              2020
C  KDIM4  - MAXIMUM NUMBER OF EVENT LABELS IN THE DICTIONARY            2030
C  KDIM5  - MAXIMUM NUMBER OF FOSSILS PERMITTED TO BE IMPLICATED IN     2040
C             ONE CYCLE                                                 2050
C  KDIM6  - MAXIMUM NUMBER OF EVENTS REMAINING AFTER FILTERING          2060
C  MAXCYC - MAXIMUM NUMBER OF CYCLES ALLOWED                            2070
C  MAXUQ  - MAXIMUM NUMBER OF UNIQUE EVENTS                             2080
C                                                                       2090
      OPEN (5,FILE='INPUT')                                             2100
      OPEN (6,FILE='OUTPUT')                                            2110
      OPEN (10,FILE='TAPE10',STATUS='OLD',ACCESS='SEQUENTIAL')          2120
      OPEN (99,FILE='TAPE99',STATUS='OLD',ACCESS='SEQUENTIAL')          2130
      OPEN (7,FILE='TAPE7',STATUS='NEW',ACCESS='SEQUENTIAL')            2140
C                                                                       2150
C  READS IN:  INPUT (RUN PARAMETERS), TAPE10 (WELL DATA),               2160
C             TAPE99 (DICTIONARY)                                       2170
C  CREATES:   OUTPUT (THE PRINT FILE OF RESULTS)                        2180
C             TAPE7 (INPUT TO 'DENO' PROGRAMME FOR DISSPLA PLOTS OF     2190
C                    OPTIMUM FOSSIL SEQUENCE AND DENDROGRAMS)           2200
C                                                                       2210
C  THIS IS RASC, VERSION 19851007                                       2220
C                                                                       2230
      WRITE (6,1000)                                                    2240
      WRITE (6,1001)                                                    2250
      WRITE (6,1002)                                                    2260
      WRITE (6,1003)                                                    2270
 1000 FORMAT (1H1, 4X, 'RESULTS OBTAINED BY MEANS OF PROGRAM RASC')     2280
 1001 FORMAT (/5X, 'PREPARED BY F.P. AGTERBERG AND L.D. NEL',           2290
     +   /5X, 'JANUARY 1981')                                           2300
 1002 FORMAT (/5X, 'REVISED BY F.P. AGTERBERG AND S.N. LEW',            2310
     +  /5X, 'SEPTEMBER 1985')                                          2320
 1003 FORMAT (/5X, 'GEOLOGICAL SURVEY OF CANADA'/5X,                    2330
     + '601 BOOTH STREET'/5X, 'OTTAWA, CANADA'/5X, 'K1A 0E8')           2340
C                                                                       2350
C     READ INPUTS                                                       2360
C     -----------                                                       2370
C                                                                       2380
      CALL READIN                                                       2390
C                                                                       2400
C                                                                       2410
C     PREPROCESSING                                                     2420
C     --------------                                                    2430
C                                                                       2440
C                                                                       2450
      WRITE (6,2000)                                                    2460
      WRITE (6,2001)                                                    2470
 2000 FORMAT (/////5X,'PREPROCESSING INITIATED')                        2480
 2001 FORMAT (5X,'-----------------------')                             2490
C                                                                       2500
C  CONSTRUCT  NUNIQ(KDIM1)  - MAP SHOWING WHICH SEQUENCES HAVE          2510
C                               UNIQUE EVENTS                           2520
C  IRCODE(KDIM4)  - BEING USED HERE AS A TABLE TO BE SENT TO            2530
C                     OCCTAB().  (REALLY ONLY NEED KDIM6 OF THE         2540
C                     KDIM4 AVAILABLE.)                                 2550
C                                                                       2560
      DO 205 I = 1,NS                                                   2570
          DO 200 J = 1,KDIM3                                            2580
              ID = TMAT(I,J)                                            2590
              AID = IABS (ID)                                           2600
              IF (AID.EQ.0) GO TO 205                                   2610
              IF (INIQ.EQ.1 .AND. IUNIQ(AID,1).EQ.1) NUNIQ(I) = 1       2620
              IRCODE(AID) = IRCODE(AID) + 1                             2630
  200     CONTINUE                                                      2640
  205 CONTINUE                                                          2650
C                                                                       2660
C  PRINT A TABLE SHOWING FOR EACH DICTIONARY EVENT THE NUMBER           2670
C  OF WELLS IN WHICH THIS EVENT APPEARS                                 2680
C                                                                       2690
      CALL OCCTAB                                                       2700
C                                                                       2710
C                                                                       2720
C  LOW OCCURRENCE FILTERING AND RECODING OF DATA                        2730
C                                                                       2740
C  ALL EVENTS IN THE DATA SET WHICH DO NOT OCCUR IN AT LEAST            2750
C  "IOCR" SEQUENCES ARE ELIMINATED, AND THE DATA ARE RE-CODED SUCH      2760
C  THAT IF "MMAX" EVENTS ARE RETAINED, THE NEW CODE NUMBERS WILL        2770
C  RUN FROM 1 TO "MMAX".                                                2780
C  "TMAT" WILL BECOME THE FILTERED (BUT NOT RE-CODED) DATA SET.         2790
C                                                                       2800
      CALL HPFILT (TMAT,IOCR,INIQ,IOMAT)                                2810
C                                                                       2820
C                                                                       2830
C  PRESORT OPTION:  A PRELIMINARY SEQUENCE IS DERIVED FROM THE SORT-    2840
C  ING OF EVENT 'SCORES' BASED ON THE FREQUENCIES OF ALL EVENTS,        2850
C  COMPARED WITH ALL OTHER EVENTS IN AN ORDER RELATION MATRIX.          2860
C                                                                       2870
      IF (ISRT.EQ.1) CALL PRESRT (IOMAT)                                2880
C                                                                       2890
C                                                                       2900
C                                                                       2910
C     RANKING SOLUTION                                                  2920
C     ----------------                                                  2930
C                                                                       2940
C                                                                       2950
C  CREATION OF CUMULATIVE ORDER MATRIX                                  2960
C                                                                       2970
C  CUMULATIVE ORDER MATRIX C(I,J) IS CONSTRUCTED SUCH THAT              2980
C  ELEMENTS C(I,J) CONTAIN THE NUMBER OF TIMES EVENT I                  2990
C  OCCURRED ABOVE (BEFORE) EVENT J.                                     3000
C                                                                       3010
      WRITE (6,3000)                                                    3020
      WRITE (6,3001)                                                    3030
 3000 FORMAT (1H1,4X,'RANKING SOLUTION')                                3040
 3001 FORMAT (5X,'----------------')                                    3050
      DO 305 I = 1,KDIM6                                                3060
          DO 300 J = 1,KDIM6                                            3070
              C(I,J) = 0.0                                              3080
  300     CONTINUE                                                      3090
  305 CONTINUE                                                          3100
      WRITE (6,3010) IOCR, INT (CRIT1)                                  3110
 3010 FORMAT (////'  RUN FOR', I2, ' OR MORE OCCURRENCES AND', I2,      3120
     + ' OR MORE PAIRS')                                                3130
C                                                                       3140
C  PRODUCES A NEW C.O. MATRIX BASED ON THE CURRENT STATE OF THE         3150
C  WELL DATA.  (THAT IS,  PRESORTED OR ...)                             3160
C                                                                       3170
C  IX  - THE RECODED DATASET                                            3180
C                                                                       3190
      DO 325 L = 1,NS                                                   3200
          J = 1                                                         3210
  307     IF (J.GT.KDIM3)  GO TO 325                                    3220
          MM = IX(L,J)                                                  3230
          IF (MM.EQ.0)  GO TO 325                                       3240
              TEST = 0                                                  3250
              K = J                                                     3260
              I = IABS (MM)                                             3270
  310         K = K + 1                                                 3280
              IF (K.GT.KDIM3)  GO TO 320                                3290
              AA = IX(L,K)                                              3300
              IF (AA.EQ.0) GO TO 320                                    3310
                  KK = IABS (AA)                                        3320
                  IF (AA.LT.0 .AND. TEST.LE.0) GO TO 315                3330
                      TEST = TEST + 1                                   3340
                      C(I,KK) = C(I,KK) + 1.0                           3350
                      GO TO 310                                         3360
  315             C(I,KK) = C(I,KK) + 0.5                               3370
                      C(KK,I) = C(KK,I) + 0.5                           3380
                      GO TO 310                                         3390
  320         J = J + 1                                                 3400
              GO TO 307                                                 3410
  325 CONTINUE                                                          3420
      IF (IOMAT.NE.1) GO TO 335                                         3430
          WRITE (6,3020)                                                3440
 3020     FORMAT (/////,24H CUMULATIVE ORDER MATRIX/)                   3450
          DO 330 I = 1,MMAX                                             3460
              WRITE (6,3030)                                            3470
 3030         FORMAT (//)                                               3480
              WRITE (6,3040) (C(I,J), J = 1,MMAX)                       3490
  330     CONTINUE                                                      3500
 3040     FORMAT (1X, 20F6.1)                                           3510
C                                                                       3520
C  MODIFICATION OF CUMULATIVE ORDER MATRIX                              3530
C                                                                       3540
C  THE TRANSPOSE ELEMENT PAIRS C(I,J) AND C(J,I)                        3550
C  WHOSE SUM IS LESS THAN CRIT1 ARE ZEROED                              3560
C                                                                       3570
  335 IKNT = 0                                                          3580
      IMAX = MMAX - 1                                                   3590
      DO 345 I = 1,IMAX                                                 3600
          L = I + 1                                                     3610
          DO 340 J = L,MMAX                                             3620
              IF ((C(I,J)+C(J,I)) .GE. CRIT1) GO TO 340                 3630
              C(I,J) = 0.0                                              3640
              C(J,I) = 0.0                                              3650
              IKNT = IKNT + 1                                           3660
  340     CONTINUE                                                      3670
  345 CONTINUE                                                          3680
      MMSQ = (MMAX * MMAX - MMAX) * 0.5                                 3690
      WRITE (6,3050)                                                    3700
 3050 FORMAT (//'  MODIFICATION OF ORDER MATRIX')                       3710
      WRITE (6,3060) CRIT1, IKNT, MMSQ                                  3720
 3060 FORMAT (/' BASED ON CRIT1 =',F5.1,',',I5,' PAIRS OUT OF',I6,      3730
     + ' HAVE BEEN ZEROED')                                             3740
      IF (IOMAT.NE.1) GO TO 400                                         3750
          WRITE (6,3070)                                                3760
 3070     FORMAT (/////25H MODIFIED RELATION MATRIX/)                   3770
          DO 350 I = 1,MMAX                                             3780
              WRITE (6,3030)                                            3790
              WRITE (6,3080) (C(I,J), J = 1,MMAX)                       3800
  350     CONTINUE                                                      3810
 3080     FORMAT (/20F6.1)                                              3820
C                                                                       3830
C  OPTIMUM SEQUENCE DETERMINED BY MATRIX TRANSFORMATION (RANKING)       3840
C                                                                       3850
C  AN OPTIMUM SEQUENCE IS DETERMINED BY EXAMINING THE ORDER MATRIX.     3860
C  FREQUENCIES (TRANSPOSE ELEMENTS C(I,J) AND C(J,I) ) ARE              3870
C  COMPARED AND ROWS AND COLUMNS I AND J ARE INTERCHANGED SUCH THAT     3880
C  ALL LARGER ELEMENTS APPEAR IN THE UPPER TRIANGLE OF THE MATRIX       3890
C                                                                       3900
C  IA     - NUMBER OF CYCLES              COUNT  - # OF ITERATIONS      3910
C  ICORT  - (A SWITCH;  SENT TO CYCLE SUBRTN.)                          3920
C  ICYC   - # FOSSILS IN THE CYCLE;  SENT TO CYCLE SUBRTN.              3930
C                                                                       3940
  400 IA = 1                                                            3950
      DO 405 I = 1,KDIM6                                                3960
          IPOS(I) = I                                                   3970
  405 CONTINUE                                                          3980
      IF (ISKIP.EQ.1) GO TO 480                                         3990
      COUNT = 0                                                         4000
      ICORT = 0                                                         4010
      DO 470 I = 1,MMAX                                                 4020
  410     IF (IA.LE.MAXCYC) GO TO 415                                   4030
              WRITE (6,4000) MAXCYC                                     4040
 4000         FORMAT (/1X, '*** NUMBER OF CYCLES HAS EXCEEDED THE',     4050
     +         ' ALLOWED MAXIMUM OF', I5, '.',                          4060
     +         //1X, '**** EXECUTION TERMINATED.'/)                     4070
              GO TO 9999                                                4080
  415     ICYC = 0                                                      4090
          ISUP = 0                                                      4120
          DO 420 J = 1,KDIM5                                            4130
              WVEC(J) = 0.0                                             4140
  420     CONTINUE                                                      4150
  425     K = I + 1                                                     4160
          IF (K.GT.MMAX) GO TO 470                                      4170
          DO 465 J = K,MMAX                                             4180
              IF (C(I,J).GE.(C(J,I)-TOL)) GO TO 465                     4190
              DO 430 T = 1,MMAX                                         4200
                  TEMP = C(I,T)                                         4210
                  C(I,T) = C(J,T)                                       4220
                  C(J,T) = TEMP                                         4230
  430         CONTINUE                                                  4240
              DO 435 T = 1,MMAX                                         4250
                  TEMP = C(T,I)                                         4260
                  C(T,I) = C(T,J)                                       4270
                  C(T,J) = TEMP                                         4280
  435         CONTINUE                                                  4290
              ITEMP = IPOS(I)                                           4300
              IPOS(I) = IPOS(J)                                         4310
              IPOS(J) = ITEMP                                           4320
              LIMT = KDIM5 - 1                                          4330
              DO 440 T = 1,LIMT                                         4340
                  WVEC(T) = WVEC(T+1)                                   4350
  440         CONTINUE                                                  4360
              WVEC(KDIM5) = FLOAT (IPOS(I))                             4370
              COUNT = COUNT + 1                                         4380
              IF (COUNT.LT.ITER) GO TO 445                              4390
                  WRITE (6,4020) ITER                                   4400
 4020             FORMAT (/1X, '*** NUMBER OF ALLOWED MATRIX TRANS',    4410
     +             'FORMATIONS (ITER =', I6, ') EXCEEDED.',             4420
     +             //1X, '**** EXECUTION TERMINATED IN M/PROG.'/)       4430
                  GO TO 9999                                            4440
  445         IF (IALPHA.EQ.0 .OR. IALPHA.EQ.1)  GO TO 450              4450
                  WRITE (6,4050)                                        4460
 4050             FORMAT (//20H SEQUENCING PROGRESS)                    4470
                  WRITE (6,4060) (IPOS(L), L = 1,MMAX)                  4480
 4060             FORMAT (1X, 20I5)                                     4490
  450         CONTINUE                                                  4500
C                                                                       4510
C          TEST AND CORRECT FOR CYCLICITY                               4520
C                                                                       4530
              ISUP = ISUP + 1                                           4540
              IF (ISUP.LE.100 .OR. WVEC(1).LE.0.0) GO TO 425            4550
              DO 455 T = 4,KDIM5                                        4560
                  IF (WVEC(T).EQ.WVEC(1)) GO TO 460                     4570
  455         CONTINUE                                                  4580
              GO TO 425                                                 4590
  460         ICYC = T - 1                                              4600
              CALL CYCLE (ICORT,ICYC,WVEC,IA,A,B,CC,IPOS)               4610
              GO TO 410                                                 4620
  465     CONTINUE                                                      4630
  470 CONTINUE                                                          4640
C                                                                       4650
C  REPLACE ELEMENTS ZEROED IN CORRECTION OF CYCLICITY                   4660
C                                                                       4670
      ICORT = 1                                                         4680
      CALL CYCLE (ICORT,ICYC,WVEC,IA,A,B,CC,IPOS)                       4690
C                                                                       4700
C                                                                       4710
C  OUTPUT FINAL ORDER RELATION MATRIX, OPTIMUM SEQUENCE                 4720
C  AND RUN CONDITIONS                                                   4730
C                                                                       4740
C                                                                       4750
      IF (IOMAT.NE.1) GO TO 480                                         4760
          WRITE (6,4070)                                                4770
 4070     FORMAT (///1X, 'FINAL ORDER RELATION MATRIX')                 4780
          DO 475 I = 1,MMAX                                             4790
              WRITE (6,4080) I                                          4800
 4080         FORMAT (//2X,I3)                                          4810
              WRITE (6,3080) (C(I,J), J = 1,MMAX)                       4820
  475     CONTINUE                                                      4830
C                                                                       4840
  480 WRITE (6,4090)                                                    4850
 4090 FORMAT (///// ' OPTIMUM SEQUENCE OBTAINED VIA RANKING'/)          4860
      WRITE (6,4060) (IPOS(L), L = 1,MMAX)                              4870
      DO 485 I = 1,MMAX                                                 4880
          IRCODE(I) = ICODE(IPOS(I))                                    4890
  485 CONTINUE                                                          4900
C                                                                       4910
C  IPOS   - HOLDS THE OPT. SEQ.  (ENCODED RASC INDEX-NUMBERS)           4920
C  IRCODE - HOLDS THE OPT. SEQ.  (ORIGINAL CODE NUMBERS)                4930
C                                                                       4940
      WRITE (6,4100)                                                    4950
 4100 FORMAT (///// ' OPTIMUM SEQUENCE USING ORIGINAL CODE NUMBERS')    4960
      WRITE (6,4110) (IRCODE(I), I = 1,MMAX)                            4970
 4110 FORMAT (1X, 20I5)                                                 4980
      WRITE (6,4130) COUNT, ITER                                        4990
 4130 FORMAT (///// ' RANKING SOLUTION OBTAINED WITH:' //10X, I5,       5000
     +  ' ITERATIONS OUT OF MAXIMUM',I7)                                5010
      WRITE (6,4150) CRIT1, TOL                                         5020
 4150 FORMAT (//10X, 'CRITICAL TRANSPOSE ELEMENT SUM OF', F6.1,         5030
     +  //10X, 'TOLERANCE OF', F6.1)                                    5040
C                                                                       5050
C                                                                       5060
C     EVENT RANGES                                                      5070
C     ------------                                                      5080
C                                                                       5090
C  PRINT SEQUENCE WITH NAMES (EVENT LABELS) AND RANGES                  5100
C  (WE MAKE USE OF THE CUM.ORDER MATRIX AND THE CORRESPONDING           5110
C    POSITION MATRIX)                                                   5120
C                                                                       5130
C                                                                       5140
      DO 520 I = 1,MMAX                                                 5150
          K = I                                                         5160
  500     K = K - 1                                                     5170
              IF (K.EQ.0) GO TO 505                                     5180
              ARG = C(K,I) - C(I,K)                                     5190
              IF (ARG.LE.0.0) GO TO 500                                 5200
  505     INK = K                                                       5210
          K = I                                                         5220
  510     K = K + 1                                                     5230
              IF (K.EQ.(MMAX+1)) GO TO 515                              5240
              ARG = C(I,K) - C(K,I)                                     5250
              IF (ARG.LE.0.0) GO TO 510                                 5260
  515     JNK = K                                                       5270
          IRANGE(I,1) = INK                                             5280
          IRANGE(I,2) = JNK                                             5290
  520 CONTINUE                                                          5300
      WRITE (6,7040)                                                    5310
 7040 FORMAT (////10X,'NUMERICAL LISTING'//)                            5320
      DO 525 I = 1,N                                                    5330
          WRITE (6,7050) I, (ITITLE(I,J), J = 1,10)                     5340
 7050     FORMAT (1X, I5, 2X, 10A4)                                     5350
  525 CONTINUE                                                          5360
      NCOLS = 10                                                        5370
      CALL ASORT (NCOLS)                                                5380
      WRITE (6,5010)                                                    5390
      WRITE (6,5020)                                                    5400
      WRITE (6,5030)                                                    5410
      WRITE (6,5040)                                                    5420
 5010 FORMAT ('1', 'OPTIMUM SEQUENCE TABULATED WITH EVENT RANGES AND',  5430
     +  ' LABELS:'///)                                                  5440
 5020 FORMAT (7X, 'SEQUENCE  FOSSIL  RANGE   FOSSIL    - RANGES',       5450
     + ' DEFINE OUTER LIMITS IN THE POSITION SEQUENCE.  EVENTS CAN',    5460
     + ' OCCUR ANYWHERE')                                               5470
 5030 FORMAT (7X, 'POSITION  NUMBER', 10X, 'NAME', 8X, 'WITHIN THESE',  5480
     + ' LIMITS.  (NOTE: THIS RANGE IS NOT STRATIGRAPHIC)')             5490
 5040 FORMAT (//)                                                       5500
      DO 530 I = 1,MMAX                                                 5510
          ID = IRCODE(I)                                                5520
          JIRCOD(I) = ID                                                5530
          WRITE (6,5050) I, ID, IRANGE(I,1), IRANGE(I,2),               5540
     +      (ITITLE(ID,J), J = 1,10)                                    5550
          WRITE (7,5047) I, ID, IRANGE(I,1), IRANGE(I,2),               5560
     +      (ITITLE(ID,J), J = 1,10)                                    5570
 5047     FORMAT (1X, I8, I9, I8, I4, 3X, 10A4)                         5580
 5050     FORMAT (1X, I8, I9, I8, '-', I3, 3X, 10A4)                    5590
  530 CONTINUE                                                          5600
C                                                                       5610
C  JIRCOD  - A COPY OF THE OPTIMUM SEQUENCE OBTAINED BY RANKING.        5620
C            (ORIGINAL FOSSIL NUMBERS).  TO BE USED AS INPUT TO WDIST().5630
C                                                                       5640
      IF (ISCAT.NE.1)  GO TO 534                                        5650
          WRITE (6,5055)                                                5660
 5055     FORMAT ('1', 'CORRELATION OF WELL SEQUENCE DATA TO OPTIMUM',  5670
     +     ' SEQUENCE'/)                                                5680
          DO 533 IS = 1,NS                                              5690
              DO 531 I = 1,KDIM3                                        5700
                  IQD(I) = TMAT(IS,I)                                   5710
                  IF (IQD(I).EQ.0) GO TO 532                            5720
                  NED = I                                               5730
  531         CONTINUE                                                  5740
  532         WRITE (6,5060) (NAME(IS,J), J = 1,5)                      5750
 5060         FORMAT (///2X, 5A4/)                                      5760
              CALL SCATTR (IQD,NED,IS)                                  5770
  533     CONTINUE                                                      5780
  534 IF (IALPHA.EQ.1) GO TO 535                                        5790
          IF (ITAB1.EQ.1) CALL TAB1                                     5800
          IF (ISCORE.EQ.1) CALL SCORE                                   5810
          GO TO 9999                                                    5820
C                                                                       5830
C                                                                       5840
C     SCALING ANALYSIS                                                  5850
C     ----------------                                                  5860
C                                                                       5870
C  SECOND MODIFICATION OF CUMULATIVE ORDER MATRIX                       5880
C                                                                       5890
  535 IF (CRIT2.LE.CRIT1) GO TO 590                                     5900
          IKNT = 0                                                      5910
          DO 560 I = 1,IMAX                                             5920
              L = I + 1                                                 5930
              DO 550 J = L,MMAX                                         5940
                  IF (C(I,J)+C(J,I).GE.CRIT2) GO TO 550                 5950
                  C(I,J) = 0.0                                          5960
                  C(J,I) = 0.0                                          5970
                  IKNT = IKNT + 1                                       5980
  550         CONTINUE                                                  5990
  560     CONTINUE                                                      6000
          WRITE (6,5070) CRIT2, IKNT, MMSQ                              6010
 5070     FORMAT (//1X, 'SECOND MODIFICATION OF ORDER MATRIX:',         6020
     +      /6X, 'BASED ON CRIT2 = ', F5.1, ', A TOTAL OF', I5,         6030
     +      ' PAIRS (OUT OF', I5, ') HAVE BEEN ZEROED.')                6040
          IF (IOMAT.NE.1) GO TO 590                                     6050
          WRITE (6,3070)                                                6060
          DO 570 I = 1,MMAX                                             6070
              WRITE (6,3030)                                            6080
              WRITE (6,3080) (C(I,J), J = 1,MMAX)                       6090
  570     CONTINUE                                                      6100
C                                                                       6110
C     (IF LLL = 1,  THEN RESULTS OF SCALING WILL NOT BE PRINTED)        6120
  590 LLL = INOSC                                                       6130
      IF (INOSC.EQ.1) LLL = 0                                           6140
      WRITE (6,6000)                                                    6150
      WRITE (6,6010)                                                    6160
 6000 FORMAT (1H1,4X,'SCALING ANALYSIS')                                6170
 6010 FORMAT (5X,'----------------')                                    6180
C                                                                       6190
C  EVALUATION OF OPTIMUM SEQUENCE BASED ON UNWEIGHTED AND WEIGHTED      6200
C      DISTANCE ANALYSIS                                                6210
C                                                                       6220
      WRITE (6,6020)                                                    6230
 6020 FORMAT (//'  EVALUATION BASED ON UNWEIGHTED AND WEIGHTED',        6240
     + ' DISTANCE ANALYSIS')                                            6250
C                                                                       6260
C  COMPUTE NORMAL Z VALUES OF FREQUENCIES CALCULATED FROM ORDER MATRIX  6270
C                                                                       6280
      CALL NORMZ (AAA,LLL,IOMAT)                                        6290
C                                                                       6300
C  COMPUTE 'DISTANCES' BETWEEN EVENTS AND CONSTRUCT DENDROGRAM          6310
C                                                                       6320
C                                                                       6330
      CALL DIST (QDAR,MPAIR,AAA,LLL)                                    6340
      LOUT = 0                                                          6350
      CALL ORDER (QDAR,IPAIR,XLEV,LLL,LOUT)                             6360
      IF (LLL.NE.0) WRITE (6,7010)                                      6370
 7010 FORMAT (//5X,'DENDROGRAM OF UNWEIGHTED INTERFOSSIL DISTANCES'//)  6380
      IF (LLL.NE.0) CALL DENDRO (IPAIR,XLEV)                            6390
C                                                                       6400
C  REPEAT DISTANCE ANALYSIS WITH WEIGHTED DIFFERENCES                   6410
C                                                                       6420
      LLL = INOSC                                                       6430
      CALL WDIST (JIRCOD,QDAR,MPAIR,AAA,LLL,INEG,CRIT2)                 6440
      LOUT = 1                                                          6450
      CALL ORDER (QDAR,IPAIR,XLEV,LLL,LOUT)                             6460
      IF (LLL.NE.0) WRITE (6,7020)                                      6470
 7020 FORMAT (//5X,'DENDROGRAM OF WEIGHTED INTERFOSSIL DISTANCES'//)    6480
      IF (LLL.NE.0) CALL DENDRO (IPAIR,XLEV)                            6490
C                                                                       6500
C  REORDER FINAL RELATION MATRIX AND REPEAT CLUSTER ANALYSIS            6510
C      FOR UNWEIGHTED AND WEIGHTED DIFFERENCES                          6520
C                                                                       6530
      IF (IFIN.NE.1) GO TO 700                                          6540
      DO 625 KKK = 1,5                                                  6550
          IRET  = 1                                                     6560
          DO 600 I = 1,MMAX                                             6570
              IF (JIRCOD(I).NE.IRCODE(I)) IRET = 0                      6580
  600     CONTINUE                                                      6590
          IF (KKK.EQ.5) IRET = 1                                        6600
          LLL = IRET                                                    6610
          IF (IRET.NE.1) GO TO 610                                      6620
          WRITE (6,6030)                                                6630
 6030     FORMAT (1H1)                                                  6640
          WRITE (6,6040)                                                6650
 6040     FORMAT (/'  APPLICATION OF FINAL REORDERING'//)               6660
          WRITE (6,6050)                                                6670
 6050     FORMAT ('  DISTANCES ESTIMATED FROM SUCCESSIVE EVENTS'///)    6680
          WRITE (6,6051)                                                6690
 6051     FORMAT (/4X, 'TO RECALCULATE STANDARD DEVIATIONS, DISTANCE',  6700
     +     ' VALUES HAVE TO BE RECALCULATED STARTING WITH THE NEW',     6710
     +     ' SEQUENCE'//)                                               6720
          IF (IOMAT.NE.1) GO TO 620                                     6730
              WRITE (6,6060)                                            6740
 6060         FORMAT (////'  UPPER TRIANGLE OF NORMAL Z VALUES')        6750
              DO 605 I = 1,MMAX                                         6760
                  WRITE (6,6070)                                        6770
 6070             FORMAT (///)                                          6780
                  WRITE (6,6080) (C(I,J), J = 1,MMAX)                   6790
 6080             FORMAT (1X,15F8.3)                                    6800
  605         CONTINUE                                                  6810
              GO TO 620                                                 6820
  610     CALL REORD (AAA,IPOS)                                         6830
              DO 615 I = 1,MMAX                                         6840
                  JIRCOD(I) = IRCODE(I)                                 6850
  615         CONTINUE                                                  6860
              LLL = 0                                                   6870
              IF (INOSC.GT.1 .AND. IRET.EQ.1) LLL = 1                   6880
C                                                                       6890
C             COMPUTE NORMAL Z VALUES                                   6900
C                                                                       6910
              CALL NORMZ (AAA,LLL,IOMAT)                                6920
C                                                                       6930
C             COMPUTE DISTANCES BETWEEN FOSSIL EVENTS                   6940
C                                                                       6950
 620      LLL = 0                                                       6960
          IF (INOSC.GT.1 .AND. IRET.EQ.1) LLL = 1                       6970
          CALL DIST (QDAR,MPAIR,AAA,LLL)                                6980
          LOUT = 0                                                      6990
          CALL ORDER (QDAR,IPAIR,XLEV,LLL,LOUT)                         7000
          IF (LLL.NE.0) WRITE (6,7010)                                  7010
          IF (LLL.NE.0) CALL DENDRO (IPAIR,XLEV)                        7020
C                                                                       7030
C      REPEAT DISTANCE CALCULATION WITH WEIGHTED DIFFERENCES            7040
C                                                                       7050
          LLL = 0                                                       7060
          IF (INOSC.GE.1 .AND. IRET.EQ.1) LLL = 1                       7070
          CALL WDIST (JIRCOD,QDAR,MPAIR,AAA,LLL,INEG,CRIT2)             7080
          LOUT = 1                                                      7090
          CALL ORDER (QDAR,IPAIR,XLEV,LLL,LOUT)                         7100
          IF (LLL.NE.0) WRITE (6,7020)                                  7110
          IF (LLL.NE.0) CALL DENDRO (IPAIR,XLEV)                        7120
          IF (IRET.EQ.1) GO TO 630                                      7130
  625 CONTINUE                                                          7140
  630 WRITE (6,6090) KKK                                                7150
 6090 FORMAT (///' SOLUTION AFTER ',I3,' ITERATIONS'///)                7160
C                                                                       7170
C                                                                       7180
C                                                                       7190
C     FINAL PROCESSING OPTIONS                                          7200
C     ------------------------                                          7210
C                                                                       7220
C                                                                       7230
C  CONSTRUCT OCCURRENCE TABLE FOR WELLS                                 7240
C                                                                       7250
  700 IF (ITAB1.EQ.1) CALL TAB1                                         7260
C                                                                       7270
C  STEP MODEL FOR INDIVIDUAL WELLS                                      7280
C                                                                       7290
      IF (ISCORE.EQ.1) CALL SCORE                                       7300
C                                                                       7310
      IF (ISCAT.NE.1) GO TO 850                                         7320
      WRITE (6,5055)                                                    7330
      DO 800 I = 1,NS                                                   7340
          DO 790 J = 1,KDIM3                                            7350
              IQD(J) = TMAT(I,J)                                        7360
              IF (IQD(J).EQ.0) GO TO 795                                7370
              NED = J                                                   7380
  790     CONTINUE                                                      7390
  795     WRITE (6,5060) (NAME(I,J), J = 1,5)                           7400
          CALL SCATTR (IQD,NED,I)                                       7410
  800 CONTINUE                                                          7420
C                                                                       7430
C  PERFORM NORMALITY TEST ON INDIVIDUAL WELLS                           7440
C                                                                       7450
  850 IF (ICOMP.EQ.1) CALL COMP (QDAR,INIQ)                             7460
C                                                                       7470
C  ENTER UNIQUE EVENTS INTO SEQUENCE AND PRINT FINAL DENDROGRAM         7480
C                                                                       7490
      IF (INIQ.NE.1 .OR. ICOMP.NE.1) GO TO 9999                         7500
          WRITE (6,7000)                                                7510
 7000     FORMAT ('1', 'POSITIONING OF UNIQUE EVENTS IN FINAL SEQUENCE')7520
          CALL ORDER (QDAR,IPAIR,XLEV,LLL,0)                            7530
          CALL DENDRO (IPAIR,XLEV)                                      7540
C                                                                       7550
 9999 STOP                                                              7560
      END                                                               7570
      SUBROUTINE ASORT (NC)                                             7580
C                                                                       7590
C ... PRINTS ALPHABETIC LISTING OF DICTIONARY.  USES FUNCTION LLE(),    7600
C  "LEXICALLY LESS THAN OR EQUAL TO".  THIS ROUTINE IS SOMEWHAT         7610
C  TIME CONSUMING AND MAY BE OMITTED BY REMOVING ITS CALL.              7612
C                                                                       7620
C  CALLED IN MAIN PROGRAMME                                             7630
C                                                                       7640
      PARAMETER (KDIM1=25, KDIM3=120, KDIM4=280, KDIM5=10, KDIM6=145)   7646
      COMMON  N, NS, MMAX, IX(KDIM1,KDIM3), ICODE(KDIM4), IRCODE(KDIM4),7650
     +        C(KDIM6,KDIM6)                                            7652
      COMMON /TEXT/ NAME(KDIM1,5), ITITLE(KDIM4,10)                     7660
      DIMENSION    IPOS(KDIM4)                                          7670
      CHARACTER*4  NAME, ITITLE                                         7680
      CHARACTER*40 FOSSIL(KDIM4), TEMP                                  7682
C                                                                       7690
      DO 2000 I = 1,N                                                   7700
          IPOS(I) = I                                                   7710
          WRITE (FOSSIL(I),1800) (ITITLE(I,J), J = 1,NC)                7720
 1800     FORMAT (20A4)                                                 7730
 2000 CONTINUE                                                          7740
      JMAX = N - 1                                                      7750
 3000 IFLAG = 0                                                         7760
      DO 6000 J = 1,JMAX                                                7770
          IF (LLE (FOSSIL(J), FOSSIL(J+1)) )  GO TO 6000                7780
               ITEMP = IPOS(J)                                          7790
               IPOS(J) = IPOS(J+1)                                      7800
               IPOS(J+1) = ITEMP                                        7810
               TEMP = FOSSIL(J)                                         7820
               FOSSIL(J) = FOSSIL(J+1)                                  7830
               FOSSIL(J+1) = TEMP                                       7840
               IFLAG = 1                                                7850
 6000 CONTINUE                                                          7860
      IF (IFLAG.EQ.0)  GO TO 7000                                       7870
          JMAX = JMAX - 1                                               7880
          GO TO 3000                                                    7890
C                                                                       7900
 7000 WRITE (6,7500)                                                    7910
 7500 FORMAT (////10X,'ALPHABETIC LISTING',//)                          7920
      DO 8000 J = 1,N                                                   7930
          WRITE (6,7800) IPOS(J), FOSSIL(J)                             7940
 7800     FORMAT (1X,I5,2X,A40)                                         7950
 8000 CONTINUE                                                          7960
      RETURN                                                            7970
      END                                                               8010
      SUBROUTINE CHECK (NS, CRIT1, CRIT2, IOCR, IER)                    8020
C                                                                       8030
C ... SUBROUTINE TO CHECK THE VALUES OF THE INPUT VARIABLES.            8040
C  ISSUES ERROR MESSAGES WHERE APPROPRIATE AND ADVISES CALLING          8050
C  PROGRAMME TO TERMINATE EXECUTION.                                    8060
C  RETURNS  "IER"                                                       8070
C                                                                       8080
C  CALLED BY SUBROUTINE READIN                                          8090
C                                                                       8100
      PARAMETER (KDIM1=25, KDIM3=120, KDIM4=280, KDIM5=10, KDIM6=145)   8110
      LOGICAL FLAG                                                      8120
C                                                                       8130
      FLAG = .FALSE.                                                    8140
      IER = 0                                                           8150
 1100 IF (NS.GE.1 .AND. NS.LE.KDIM1)  GO TO 2200                        8160
           FLAG = .TRUE.                                                8170
           IF (NS.GT.KDIM1)  GO TO 1310                                 8180
                WRITE (6,1300)                                          8190
 1300           FORMAT (///1X, '*** ERROR:   NS  LESS THAN 1 (ONE)')    8200
                GO TO 2200                                              8210
 1310      WRITE (6,1315) KDIM1, KDIM1                                  8220
 1315           FORMAT (///1X, '*** ERROR:   NS  GREATER THAN', I4,     8230
     +          /16X, 'FOR MORE THAN', I4, ' WELLS,')                   8240
                WRITE (6,1320)                                          8250
 1320           FORMAT (11X, 'PLEASE USE A LARGER VERSION OF RASC')     8260
C                                                                       8270
 2200 IF (CRIT2.GE.CRIT1)  GO TO 2400                                   8280
           WRITE (6,2230)                                               8290
 2230      FORMAT (///1X, '** WARNING:  CRIT2 LESS THAN CRIT1',         8300
     +     /16X, 'CRIT2 HAS BEEN SET EQUAL TO CRIT1')                   8310
           CRIT2 = CRIT1                                                8320
C                                                                       8330
 2400 IF (CRIT1 .LE. FLOAT(IOCR))  GO TO 9000                           8340
           FLAG = .TRUE.                                                8350
           WRITE (6,2430)                                               8360
 2430      FORMAT (///1X, '*** ERROR:   CRIT1 GREATER THAN "IOCR"')     8370
C                                                                       8380
 9000 IF (.NOT.FLAG)  GO TO 9900                                        8390
           WRITE (6,9200)                                               8400
 9200      FORMAT (///1X, 'AN ERROR HAS BEEN DETECTED IN THE INPUT',    8410
     +     ' PARAMETERS.'//6X, '**** EXECUTION WILL BE TERMINATED.')    8420
           IER = 1                                                      8430
C                                                                       8440
 9900 RETURN                                                            8450
      END                                                               8460
      SUBROUTINE COMP (QDAR,INIQ)                                       8470
C                                                                       8480
C ... SUBROUTINE TO PERFORM NORMALITY TEST ON INDIVIDUAL WELLS          8490
C  AND TO FIT UNIQUE EVENTS INTO OPTIMUM SEQUENCE                       8500
C                                                                       8510
C  RETURNS:  MMAX   - THE REVISED MMAX FOR ORDER() AND DENDRO()         8520
C            QDAR   - SAME AS ORIGINAL QDAR FROM WDIST(),               8530
C                       BUT WITH UNIQUE EVENTS APPENDED.                8540
C                       SENT TO ORDER()                                 8550
C                                                                       8560
C  OBTAINS "RUNIQ" FROM CALL TO XUNIQ2()                                8570
C                                                                       8580
C  CALLED IN MAIN PROGRAMME                                             8590
C                                                                       8600
      PARAMETER (KDIM1=25, KDIM3=120, KDIM4=280, KDIM5=10, KDIM6=145)   8610
      PARAMETER (MAXCYC=300, MAXUQ=20)                                  8620
      COMMON  N, NS,MMAX, IX(KDIM1,KDIM3), ICODE(KDIM4), IRCODE(KDIM4), 8630
     +        C(KDIM6,KDIM6)                                            8640
      COMMON /BETA/ IUNIQ(KDIM4,2), NUNIQ(KDIM1), MUNIQ(KDIM1,MAXUQ*2)  8650
      COMMON /TEXT/ NAME(KDIM1,5), ITITLE(KDIM4,10)                     8660
      INTEGER IVEC(KDIM3)                                               8670
      REAL    CLAS(10), CLASS(10), QDAR(KDIM6+MAXUQ), RMAT(KDIM3,3),    8680
     +        RUNIQ(KDIM4,2), SECDIF(3000)                              8690
      CHARACTER*4  NAME, ITITLE, IBLANK, IASK1, IASK2, ISYM             8700
      DATA  NCLASS/10/, VSMALL/1.0E-7/, CONST7/0.463/,                  8710
     +      LEN/10/, CONST8/1.73205/, CONS11/1.960/, CONS12/2.576/,     8720
     +      IBLANK/'    '/, IASK1/' * '/, IASK2/' **'/                  8730
C                                                                       8740
C  THE VALUE OF "CONST7" COMES FROM STATISTICAL TABLES FOR              8750
C  TRUNCATED NORMAL DISTRIBUTION IN                                     8760
C                                                                       8770
C      JOHNSON, N.L. AND KOTZ, S.                                       8780
C      "DISTRIBUTIONS IN STATISTICS:                                    8790
C         CONTINUOUS UNIVARIATE DISTRIBUTIONS - 1"                      8800
C      PUB. BY WILEY.     NEW YORK, 1970.                               8810
C                                                                       8820
C  CONST8 = SQRT(3)                                                     8830
C  IVEC(KDIM3)  - FOR STORING ORIGINAL CODE NUMBERS OF OBSERVED DATA,   8840
C         BUT ORDERED ACCORDING TO THE OPTIMUM SEQUENCE ESTABLISHED     8850
C         AND WITH NEGATIVE VALUES WHENEVER AN EVENT IS ON THE SAME     8860
C         LEVEL AS A PRECEDING EVENT.                                   8870
C  RMAT(KDIM3, 3)                                                       8880
C         COLUMN 1:  CUMULATIVE DISTANCES                               8890
C         COLUMN 2:  FIRST ORDER DIFFERENCES                            8900
C         COLUMN 3:  SECOND ORDER DIFFERENCES                           8910
C  SECDIF(KDIM1 * KDIM3)  IS ALSO FOR SECOND ORDER DIFFERENCES,         8920
C         BUT VALUES ARE STORED AS ONE CONTINUOUS SEQUENCE.             8930
C                                                                       8940
      DO 10 K = 1,10                                                    8950
          CLASS(K) = 0.0                                                8960
          CLAS(K) = 0.0                                                 8970
   10 CONTINUE                                                          8980
      DO 20 I = 1,N                                                     8990
          RUNIQ(I,1) = 0.0                                              9000
          RUNIQ(I,2) = 0.0                                              9010
   20 CONTINUE                                                          9020
      KK = 0                                                            9030
C                                                                       9040
C  MAJOR LOOP TO OBTAIN SECOND ORDER DIFFERENCE STATISTICS              9050
C  AND VALUES FOR "A95" AND "A99"                                       9060
C                                                                       9070
      DO 150 I = 1,NS                                                   9080
          RSTEP = 0.0                                                   9090
          DO 30 J = 1,KDIM3                                             9100
              ID = IX(I,J)                                              9110
              IF (ID.GT.0) RSTEP = RSTEP + 1.0                          9120
              IF (ID.EQ.0) GO TO 40                                     9130
   30     CONTINUE                                                      9140
   40     RSTEP = RSTEP - 1.0                                           9150
          DO 50 K = 1,KDIM3                                             9160
              RMAT(K,1) = 0.0                                           9170
              RMAT(K,2) = 0.0                                           9180
              RMAT(K,3) = 0.0                                           9190
              IVEC(K) = 0                                               9200
   50     CONTINUE                                                      9210
          ICNT = 0                                                      9220
          DO 80 J = 1,KDIM3                                             9230
              ID = IX(I,J)                                              9240
              IF (ID.EQ.0) GO TO 90                                     9250
              IAD = IABS (ID)                                           9260
              ICD = ICODE(IAD)                                          9270
              DO 60 K = 1,MMAX                                          9280
                  IF (IRCODE(K).EQ.ICD) GO TO 70                        9290
   60         CONTINUE                                                  9300
   70         ID2 = K                                                   9310
              IF (J.EQ.1) IMIN = ID2                                    9320
              IF (ID.LT.0) ICD = ICD * (-1)                             9330
              IVEC(J) = ICD                                             9340
              RMAT(J,1) = QDAR(ID2)                                     9350
              ICNT = ICNT + 1                                           9360
   80     CONTINUE                                                      9370
   90     IMAX = ID2                                                    9380
          ICN = ICNT - 1                                                9390
C                                                                       9400
C      "ICNT" IS THE LENGTH OF THE SEQUENCE                             9410
C                                                                       9420
          DO 100 J = 1,ICN                                              9430
              QRAY = RMAT(J+1,1) - RMAT(J,1)                            9440
              AVEINC = (QDAR(IMAX) - QDAR(IMIN)) / RSTEP                9450
              IF (IVEC(J+1).GT.0) QRAY = QRAY - AVEINC                  9460
              RMAT(J,2) = QRAY                                          9470
  100     CONTINUE                                                      9480
          DO 110 J = 2,ICN                                              9490
              JM1 = J - 1                                               9500
              RMAT(J,3) = RMAT(J,2) - RMAT(JM1,2)                       9510
              RMA = RMAT(J,3)                                           9520
              KK = KK + 1                                               9530
              SECDIF(KK) = RMA                                          9540
  110     CONTINUE                                                      9550
  150 CONTINUE                                                          9560
      XXX = FLOAT (KK)                                                  9570
      XXK = XXX * 0.2                                                   9580
      KXX = INT (XXK + 0.5)                                             9590
      XX = KK - (2 * KXX)                                               9600
      K = 1                                                             9610
C                                                                       9620
  220 BIGPOS = SECDIF(1)                                                9630
      DO 200 I = 1,KK                                                   9640
          IF (SECDIF(I).GE.BIGPOS)  GO TO 240                           9650
              GO TO 200                                                 9660
  240     BIGPOS = SECDIF(I)                                            9670
              IHIGH = I                                                 9680
  200 CONTINUE                                                          9690
      SECDIF(IHIGH) = VSMALL                                            9700
C                                                                       9710
      BIGNEG = SECDIF(1)                                                9720
      DO 210 I = 1,KK                                                   9730
          IF (SECDIF(I).LE.BIGNEG)  GO TO 230                           9740
              GO TO 210                                                 9750
  230     BIGNEG = SECDIF(I)                                            9760
              ILOW = I                                                  9770
  210 CONTINUE                                                          9780
      SECDIF(ILOW) = VSMALL                                             9790
      K = K + 1                                                         9800
      IF (K.LE.KXX)  GO TO 220                                          9810
C                                                                       9820
      S = 0.0                                                           9830
      SS = 0.0                                                          9840
      DO 260 I = 1,KK                                                   9850
          IF (SECDIF(I).EQ.VSMALL)  GO TO 260                           9860
          S = S + SECDIF(I)                                             9870
          SS = SS + (SECDIF(I) ** 2)                                    9880
  260 CONTINUE                                                          9890
      AVE = S / XX                                                      9900
      VAR = (SS - (XX * AVE * AVE)) / (XX - 1.0)                        9910
      SD = SQRT (VAR)                                                   9920
      SDN = SD / CONST7                                                 9930
      RATIO = SDN / CONST8                                              9940
      CQ = (SDN * SDN) + 1.0                                            9950
      RHO = 2.0 - SQRT (CQ)                                             9960
      PR = 1.0/XXX + (2.0 * RHO * (XXX / (1.-RHO) -                     9970
     +        1.0 / (1.-RHO)**2) / (XXX * XXX))                         9980
      KPR = INT (1.0 / PR + 0.5)                                        9990
C                                                                       10000
      WRITE (6,2000)                                                    10010
 2000 FORMAT (1H1, 'SECOND ORDER DIFFERENCE STATISTICS'//)              10020
      WRITE (6,2010) KK, AVE, SDN, RATIO, RHO                           10030
 2010 FORMAT (1X, 'N = ', I4, '   AVE = ', F7.5, '  SD = ',             10040
     +  F7.5, '   RATIO = ', F4.2, '   RHO = ', F5.3)                   10050
      WRITE (6,2020) KPR                                                10060
 2020 FORMAT (///1X, 'EQUIVALENT NUMBER OF VALUES = ', I4)              10070
      A95 = CONS11 * SDN                                                10080
      A99 = CONS12 * SDN                                                10090
C                                                                       10100
C                                                                       10110
C  MAJOR LOOP TO PERFORM NORMALITY TESTS FOR ALL WELLS                  10120
C                                                                       10130
      DO 280 I = 1,NS                                                   10140
          WRITE (6,1010)                                                10150
          WRITE (6,1020) (NAME(I,J), J = 1,5)                           10160
 1010     FORMAT ('1     NORMALITY TEST'//)                             10170
 1020     FORMAT (5X, 5A4 ///)                                          10180
          WRITE (6,1025)                                                10190
 1025     FORMAT (50X, 'CUM. DIST.  2ND ORDER DIFF.'/)                  10200
C                                                                       10210
          RSTEP = 0.0                                                   10220
          DO 960 J = 1,KDIM3                                            10230
              ID = IX(I,J)                                              10240
              IF (ID.GT.0)  RSTEP = RSTEP + 1.0                         10250
              IF (ID.EQ.0)  GO TO 965                                   10260
  960     CONTINUE                                                      10270
  965     RSTEP = RSTEP - 1.0                                           10280
          DO 970 K = 1,KDIM3                                            10290
              RMAT(K,1) = 0.0                                           10300
              RMAT(K,2) = 0.0                                           10310
              RMAT(K,3) = 0.0                                           10320
              IVEC(K) = 0                                               10330
  970     CONTINUE                                                      10340
          ICNT = 0                                                      10350
          DO 980 J = 1,KDIM3                                            10360
              ID = IX(I,J)                                              10370
              IF (ID.EQ.0)  GO TO 990                                   10380
              IAD = IABS (ID)                                           10390
              ICD = ICODE(IAD)                                          10400
              DO 973 K = 1,MMAX                                         10410
                  IF (IRCODE(K).EQ.ICD)  GO TO 975                      10420
  973         CONTINUE                                                  10430
  975         ID2 = K                                                   10440
              IF (J.EQ.1)  IMIN = ID2                                   10450
              IF (ID.LT.0)  ICD = ICD * (-1)                            10460
              IVEC(J) = ICD                                             10470
              RMAT(J,1) = QDAR(ID2)                                     10480
              ICNT = ICNT + 1                                           10490
  980     CONTINUE                                                      10500
  990     IMAX = ID2                                                    10510
          ICN = ICNT - 1                                                10520
C                                                                       10530
C      AGAIN, "ICNT" IS THE LENGTH OF THE SEQUENCE                      10540
C                                                                       10550
          IF (ICNT.GE.3)  GO TO 992                                     10560
              WRITE (6,991)                                             10570
  991         FORMAT (////1X, '(SORRY - RESULTS NOT POSSIBLE)')         10580
              GO TO 280                                                 10590
  992     DO 993 J = 1,ICN                                              10600
              QRAY = RMAT(J+1, 1) - RMAT(J,1)                           10610
              AVEINC = (QDAR(IMAX) - QDAR(IMIN)) / RSTEP                10620
              IF (IVEC(J+1).GT.0)  QRAY = QRAY - AVEINC                 10630
              RMAT(J,2) = QRAY                                          10640
  993     CONTINUE                                                      10650
          DO 996 J = 2,ICN                                              10660
              JM1 = J - 1                                               10670
              RMAT(J,3) = RMAT(J,2) - RMAT(JM1,2)                       10680
              RMA = RMAT(J,3)                                           10690
  996     CONTINUE                                                      10700
C                                                                       10710
          ID = IABS (IVEC(1))                                           10720
          WRITE (6,1030) (ITITLE(ID,L), L = 1,LEN), IVEC(1), RMAT(1,1)  10730
 1030     FORMAT (1X, 10A4, I4, 5X, F10.4)                              10740
          DO 120 J = 2,ICN                                              10750
              RMA = RMAT(J,3)                                           10760
              AQRAY = ABS (RMA)                                         10770
              ISYM = IBLANK                                             10780
              IF (AQRAY.GT.A95) ISYM = IASK1                            10790
              IF (AQRAY.GT.A99) ISYM = IASK2                            10800
              ID = IABS (IVEC(J))                                       10810
              WRITE (6,1040) (ITITLE(ID,L), L = 1,LEN), IVEC(J),        10820
     +            RMAT(J,1), RMAT(J,3), ISYM                            10830
 1040         FORMAT (1X,10A4,I4,5X,2F10.4,A3)                          10840
              ATEMP = RMAT(J,3) / SDN                                   10850
              CALL ZTOF (ATEMP, BTEMP)                                  10860
              RMAT(J,3) = BTEMP                                         10870
  120     CONTINUE                                                      10880
          ID = IABS (IVEC(ICNT))                                        10890
          WRITE (6,1030) (ITITLE(ID,L), L = 1,LEN), IVEC(ICNT),         10900
     +           RMAT(ICNT,1)                                           10910
          WRITE (6,1080)                                                10920
 1080     FORMAT (/10X, '*  -GREATER THAN 95% PROBABILITY THAT',        10930
     +           ' EVENT IS OUT OF POSITION')                           10940
          WRITE (6,1090)                                                10950
 1090     FORMAT (10X, '** -GREATER THAN 99% PROBABILITY THAT',         10960
     +           ' EVENT IS OUT OF POSITION')                           10970
          DO 140 K = 1,NCLASS                                           10980
              DO 130 J = 2,ICN                                          10990
                  XK = FLOAT (K) / NCLASS                               11000
                  IF (RMAT(J,3).LT.XK) CLASS(K) = CLASS(K) + 1.0        11010
  130         CONTINUE                                                  11020
  140     CONTINUE                                                      11030
          IF (INIQ.NE.1) GO TO 280                                      11040
          IF (NUNIQ(I).EQ.1) CALL XUNIQ2 (N,I,ICNT,IVEC,RMAT,RUNIQ)     11050
  280 CONTINUE                                                          11060
      WRITE (6,1010)                                                    11070
      WRITE (6,1070)                                                    11080
 1070 FORMAT (1X, 'COMPARISON OF OBSERVED AND EXPECTED OCCURRENCES OF', 11090
     + ' SECOND ORDER DIFFERENCE VALUES'///)                            11100
      WRITE (6,1060)                                                    11110
 1060 FORMAT (1X,' CLASS NO. OBSERVED  EXPECTED DIFFERENCE  DELTA'//)   11120
      TCL = FLOAT (KK) / NCLASS                                         11130
      CLAS(1) = CLASS(1)                                                11140
      DO 160 K = 2,NCLASS                                               11150
          KM1 = K - 1                                                   11160
          CLAS(K) = CLASS(K) - CLASS(KM1)                               11170
  160 CONTINUE                                                          11180
      CHI = 0.0                                                         11190
      DO 170 K = 1,NCLASS                                               11200
          DIFF = CLAS(K) - TCL                                          11210
          ICL = CLAS(K)                                                 11220
          DELTA = FLOAT (KPR) * DIFF * DIFF / (TCL * XXX)               11230
          CHI = CHI + DELTA                                             11240
          ISYM = IBLANK                                                 11250
          IF (DELTA.GT.3.84)  ISYM = IASK1                              11260
          IF (DELTA.GT.6.63)  ISYM = IASK2                              11270
          WRITE (6,1050) K, ICL, TCL, DIFF, DELTA, ISYM                 11280
  170 CONTINUE                                                          11290
      ISYM = IBLANK                                                     11300
      IF (CHI.GT.14.1)  ISYM = IASK1                                    11310
      IF (CHI.GT.18.5)  ISYM = IASK2                                    11320
      WRITE (6,2030) CHI, ISYM                                          11330
 2030 FORMAT (//1X, 26X, 'CHI-SQUARED = ', F10.3, A3)                   11340
 1050 FORMAT (1X, I6, I10, 2X, 3F10.3, A3)                              11350
      WRITE (6,2040)                                                    11360
 2040 FORMAT (/10X, '*  -GREATER THAN 95% PROBABILITY THAT',            11370
     + ' DIFFERENCE IS NOT ZERO')                                       11380
      WRITE (6,2050)                                                    11390
 2050 FORMAT (10X, '** -GREATER THAN 99% PROBABILITY THAT',             11400
     + ' DIFFERENCE IS NOT ZERO')                                       11410
      IF (INIQ.NE.1) GO TO 190                                          11420
      DO 180 I = 1,N                                                    11430
          IF (RUNIQ(I,2).LE.0.0) GO TO 180                              11440
          RUNIQ(I,1) = RUNIQ(I,1) / RUNIQ(I,2)                          11450
          MMAX = MMAX + 1                                               11460
          IF (MMAX.GT.KDIM6+MAXUQ)  WRITE (6,2060)                      11470
 2060     FORMAT (///1X, '*** ERROR:  SUBSCRIPT OUT OF RANGE IN COMP()',11480
     +      ' AT ARRAY "QDAR"'/ 16X, 'FURTHER RESULTS MAY BE ERRONEOUS')11490
          QDAR(MMAX) = RUNIQ(I,1)                                       11500
          IRCODE(MMAX) = I                                              11510
  180 CONTINUE                                                          11520
  190 RETURN                                                            11530
      END                                                               11540
      SUBROUTINE CYCLE (ICORT,ICYC,WVEC,IA,A,B,CC,IPOS)                 11550
C                                                                       11560
C ... SUBROUTINE CYCLE IS USED BY RASC TO CORRECT ARTIFICIALLY          11570
C  FOR CYCLICITY IN RANKING SOLUTION.  ALL EVENT PAIRS INVOLVED         11580
C  IN A CYCLE ARE EXAMINED AND THE ELEMENT PAIR WITH THE                11590
C  SMALLEST ABSOLUTE DIFFERENCE IS ZEROED.                              11600
C                                                                       11610
C  ACCEPTS:  ICORT  - (SWITCH)                                          11620
C                   = 1,   FOR REPLACEMENT OF ZEROED ELEMENTS           11630
C                    ELSE      SET PAIR OF ELEMENTS TO ZERO             11640
C            WVEC   - (VECTOR OF TYPE "POS")                            11650
C            IA     - NUMBER OF CYCLES                                  11660
C                                                                       11670
C  RETURNS:  A,B,CC (300,300,600)                                       11680
C            IA                                                         11690
C                                                                       11700
C  CALLED IN MAIN PROGRAMME                                             11710
C                                                                       11720
      PARAMETER (KDIM1=25, KDIM3=120, KDIM4=280, KDIM5=10, KDIM6=145)   11730
      COMMON  N, NS,MMAX, IX(KDIM1,KDIM3), ICODE(KDIM4), IRCODE(KDIM4), 11740
     +        C(KDIM6,KDIM6)                                            11750
      INTEGER IPOS(145), IQCYC(KDIM5), IRC(KDIM5)                       11760
      REAL    A(300), B(300), CC(600), RDIF(KDIM5), WVEC(KDIM5)         11770
C                                                                       11780
C  IQCYC(*) - CYCLING EVENTS (ORIGINAL CODE NUMBERS)                    11790
C  IRC(*)   - EVENT POSITIONS (BASED ON WVEC(KDIM5))                    11800
C                                                                       11810
      IF (ICORT.EQ.1) GO TO 60                                          11820
C                                                                       11830
C  DETERMINE POSITIONS OF EVENTS INVOLVED IN CYCLE                      11840
C                                                                       11850
      DO 20 L = 1,MMAX                                                  11860
          RCID = IPOS(L)                                                11870
          DO 10 J = 1,ICYC                                              11880
              IF (WVEC(J).EQ.RCID) IRC(J) = L                           11890
   10     CONTINUE                                                      11900
   20 CONTINUE                                                          11910
C                                                                       11920
C  DETERMINE MINIMUM OF ELEMENT DIFFERENCES                             11930
C                                                                       11940
      ICYCM1 = ICYC - 1                                                 11950
      DO 30 J = 1,ICYCM1                                                11960
          RDIF(J) = ABS (C(IRC(J), IRC(J+1)) - C(IRC(J+1), IRC(J)))     11970
   30 CONTINUE                                                          11980
      RDIF(ICYC) = ABS (C(IRC(ICYC), IRC(1)) - C(IRC(1), IRC(ICYC)))    11990
      DIFMIN = RDIF(1)                                                  12000
      MIN = 1                                                           12010
      DO 40 J = 2,ICYC                                                  12020
          IF(RDIF(J).GE.DIFMIN) GO TO 40                                12030
          DIFMIN = RDIF(J)                                              12040
          MIN = J                                                       12050
   40 CONTINUE                                                          12060
      MIN2 = MIN + 1                                                    12070
      IF (MIN.EQ.ICYC) MIN2 = 1                                         12080
C                                                                       12090
C  PRINT CYCLING EVENTS (ORIGINAL CODE NUMBERS), POSITIONS,             12100
C  AND MATRIX ELEMENTS.                                                 12110
C                                                                       12120
      DO 41 J = 1,ICYC                                                  12130
          IQ = IPOS(IRC(J))                                             12140
          IQCYC(J) = ICODE(IQ)                                          12150
   41 CONTINUE                                                          12160
C                                                                       12170
      WRITE (6,1000) (IQCYC(J), J = 1,ICYC)                             12180
      WRITE (6,1001) (IRC(J), J = 1,ICYC)                               12190
      WRITE (6,1002)                                                    12200
      DO 50 I = 1,ICYC                                                  12210
          WRITE (6,1003) (C(IRC(I),IRC(J)), J = 1,ICYC)                 12220
   50 CONTINUE                                                          12230
      WRITE (6,1004) IRC(MIN), IRC(MIN2), IRC(MIN2), IRC(MIN)           12240
C                                                                       12250
C  ZERO THE ELEMENT PAIR WITH THE SMALLEST DIFFERENCE                   12260
C                                                                       12270
      A(IA) = WVEC(MIN)                                                 12280
      B(IA) = WVEC(MIN2)                                                12290
      CC(IA) = C(IRC(MIN),IRC(MIN2))                                    12300
      IA = IA + 1                                                       12310
      CC(IA) = C(IRC(MIN2),IRC(MIN))                                    12320
      IA = IA + 1                                                       12330
      C(IRC(MIN),IRC(MIN2)) = 0.0                                       12340
      C(IRC(MIN2),IRC(MIN)) = 0.0                                       12350
C                                                                       12360
 1000 FORMAT (///10X, ' CYCLING EVENTS:', 9I6)                          12370
 1001 FORMAT (/10X, 'EVENT POSITIONS:', 9I6)                            12380
 1002 FORMAT (/10X, 'MATRIX ELEMENTS:')                                 12390
 1003 FORMAT (10X, 9F5.1)                                               12400
 1004 FORMAT ('  C(',I3,',',I3,') AND C(',I3,',',I3,')  ZEROED - BASED',12410
     + ' ON LEAST DIFFERENCE BETWEEN PAIRS IN THE CYCLING MATRIX')      12420
      GO TO 90                                                          12430
C                                                                       12440
C  REPLACE ELEMENTS ZEROED IN CORRECTION OF CYCLICITY                   12450
C                                                                       12460
   60 IF (IA.LE.1)  GO TO 90                                            12470
      IAM = IA - 2                                                      12480
      DO 80 I = 1,IAM,2                                                 12490
          DO 70 J = 1,MMAX                                              12500
              IF (A(I) .EQ. FLOAT (IPOS(J)))  IA1 = J                   12510
              IF (B(I) .EQ. FLOAT (IPOS(J)))  IB1 = J                   12520
   70     CONTINUE                                                      12530
          C(IA1,IB1) = CC(I)                                            12540
          C(IB1,IA1) = CC(I+1)                                          12550
   80 CONTINUE                                                          12560
   90 RETURN                                                            12570
      END                                                               12580
      SUBROUTINE DENDRO (IPAIR,XLEV)                                    12590
C                                                                       12600
C ... SUBROUTINE TO PRINT A DENDROGRAM                                  12610
C                                                                       12620
C  ADAPTED FOR RASC FROM "PROGRAM 7.8"    IN                            12630
C      DAVIS, J.C.   "STATISTICS AND DATA ANALYSIS IN GEOLOGY"          12640
C      PUB. BY WILEY.    NEW YORK, 1973.                                12650
C                                                                       12660
C  ACCEPTS:  IPAIR  - (FROM ORDER())                                    12670
C            XLEV   - (FROM ORDER())                                    12680
C                                                                       12690
C  CALLED IN MAIN PROGRAMME                                             12700
C                                                                       12710
      PARAMETER (KDIM1=25, KDIM3=120, KDIM4=280, KDIM5=10, KDIM6=145)   12720
      PARAMETER (MAXCYC=300, MAXUQ=20)                                  12730
      COMMON  N, NS,MMAX, IX(KDIM1,KDIM3), ICODE(KDIM4), IRCODE(KDIM4), 12740
     +        C(KDIM6,KDIM6)                                            12750
      COMMON  /BETA/ IUNIQ(KDIM4,2), NUNIQ(KDIM1), MUNIQ(KDIM1,MAXUQ*2) 12760
      COMMON  /TEXT/ NAME(KDIM1,5), ITITLE(KDIM4,10)                    12770
      INTEGER IPAIR(2,150)                                              12780
      REAL    XLEV(150), XX(13)                                         12790
      CHARACTER   NAME*4, ITITLE*4, ISTAR*3, ISTAR2*3                   12800
      CHARACTER*1  IBLNK, ICI, ICM, LOGO, IOUT(61)                      12810
      LOGICAL MARKON, NODON                                             12820
C                                                                       12830
      IBLNK = ' '                                                       12840
      ICI = 'I'                                                         12850
      ICM = '-'                                                         12860
      ISTAR = ' * '                                                     12870
      ISTAR2 = '** '                                                    12880
C                                                                       12890
      M2 = MMAX - 1                                                     12900
      WRITE (7,8) MMAX                                                  12910
    8 FORMAT ('***'/, 1X,I10)                                           12920
C                                                                       12930
C  FIND LARGEST AND SMALLEST SIMILARITY CO-EFFICIENT                    12940
C                                                                       12950
      XMIN = XLEV(1)                                                    12960
      XMAX = XMIN                                                       12970
      DO 10 I = 1,M2                                                    12980
          IF (XLEV(I).LT.XMIN) XMIN = XLEV(I)                           12990
          IF (XLEV(I).GT.XMAX) XMAX = XLEV(I)                           13000
   10 CONTINUE                                                          13010
      DX = (XMAX - XMIN) / 25.0                                         13020
      XMIN = XMIN - DX                                                  13030
      XMAX = XMAX + DX                                                  13040
      WRITE (7,11) XMAX,XMIN                                            13050
   11 FORMAT (1X, 2F17.8)                                               13060
      DX = -(XMAX - XMIN) / 60.0                                        13070
      XMIN = XMAX                                                       13080
C                                                                       13090
C  BLANK OUT PRINT LINE ARRAY                                           13100
C                                                                       13110
      DO 30 I = 1,61                                                    13120
          IOUT(I) = IBLNK                                               13130
   30 CONTINUE                                                          13140
C                                                                       13150
C  PRINT DENDROGRAM                                                     13160
C                                                                       13170
      X = XMIN                                                          13180
      DO 40 I = 1,13                                                    13190
          XX(I) = X                                                     13200
          X = X + (DX * 5.0)                                            13210
   40 CONTINUE                                                          13220
      WRITE (6,2000)                                                    13230
      WRITE (6,2001) (XX(I), I = 2,12,2)                                13240
      WRITE (6,2002) (XX(I), I = 1,13,2)                                13250
      WRITE (6,2003)                                                    13260
      JS = 1                                                            13270
      MARKON = .FALSE.                                                  13280
      NODON = .FALSE.                                                   13290
      NODE = IPAIR(1,1)                                                 13300
   50 X = XMIN                                                          13310
          IF (JS.NE.MMAX) X = XLEV(JS)                                  13320
          IS = IFIX ((X - XMIN) / DX) + 1                               13330
          DO 60 I = IS,61                                               13340
              IOUT(I) = ICM                                             13350
   60     CONTINUE                                                      13360
          LOGO = IBLNK                                                  13370
          IF (IUNIQ(NODE,2).EQ.1) LOGO = ISTAR                          13380
          IF (IUNIQ(NODE,2).EQ.1) MARKON = .TRUE.                       13390
          IF (IUNIQ(NODE,1).EQ.1) LOGO = ISTAR2                         13400
          IF (IUNIQ(NODE,1).EQ.1) NODON = .TRUE.                        13410
          IF (JS.NE.MMAX)                                               13420
     +    WRITE (6,2004) IOUT, NODE, X, LOGO, (ITITLE(NODE,J), J = 1,10)13430
          IF (JS.NE.MMAX)                                               13440
     +    WRITE (7,62) NODE,X,LOGO,(ITITLE(NODE,J), J=1,10)             13450
   62     FORMAT (1X, I3, F10.4, A3, 10A4)                              13460
          IF (JS.EQ.MMAX)                                               13470
     +    WRITE (6,2006) IOUT, NODE, LOGO, (ITITLE(NODE,J), J = 1,10)   13480
          IF (JS.EQ.MMAX)                                               13490
     +    WRITE (7,63) NODE,LOGO,(ITITLE(NODE,J), J=1,10)               13500
   63     FORMAT (1X, I3, A3, 10A4)                                     13510
          IF (JS.EQ.MMAX) GO TO 80                                      13520
          DO 70 I = IS,61                                               13530
              IOUT(I) = IBLNK                                           13540
   70     CONTINUE                                                      13550
          IOUT(IS) = ICI                                                13560
          WRITE (6,2004) (IOUT(I), I = 1,IS)                            13570
          NODE = IPAIR(2,JS)                                            13580
          JS = JS + 1                                                   13590
          GO TO 50                                                      13600
   80 WRITE (6,2003)                                                    13610
      WRITE (6,2002) (XX(I), I = 1,13,2)                                13620
      WRITE (6,2001) (XX(I), I = 2,12,2)                                13630
      WRITE (6,2005)                                                    13640
      IF (MARKON) WRITE(6,2007)                                         13650
      IF (NODON) WRITE(6,2008)                                          13660
 2007 FORMAT (/5X,'* INDICATES A MARKER HORIZON')                       13670
 2008 FORMAT (/5X,'** INDICATES A UNIQUE EVENT')                        13680
 2000 FORMAT (1H1)                                                      13690
 2001 FORMAT (6X,6F10.4)                                                13700
 2002 FORMAT (1X,7F10.4)                                                13710
 2003 FORMAT (6X,'+',12('----+'))                                       13720
 2004 FORMAT (6X, 61A1, 1X, I3, F10.4, 3X, 1A3, 10A4)                   13730
 2006 FORMAT (6X, 61A1, 1X, I3, 13X, 1A3, 10A4)                         13740
 2005 FORMAT ('0', 4X, 'DENDROGRAM -  VALUES ALONG X-AXIS ARE INTER',   13750
     + 'FOSSIL DISTANCES'/19X, 'VALUES ALONG Y-AXIS ARE DISTANCES',     13760
     + ' BETWEEN AN EVENT AND ITS SUCCESSOR')                           13770
      RETURN                                                            13780
      END                                                               13790
      SUBROUTINE DIST (QDAR,MPAIR,AAA,LLL)                              13800
C                                                                       13810
C ... SUBROUTINE TO COMPUTE INTER-EVENT 'DISTANCES' FOR                 13820
C  UNWEIGHTED DIFFERENCES                                               13830
C                                                                       13840
C  THIS IS A SIMPLE TECHNIQUE FOR SCALING RESULTS IN DISTANCES BETWEEN  13850
C  THE FOSSIL EVENTS WHICH ARE CLUSTERED BY MEANS OF SUBROUTINE DENDRO. 13860
C                                                                       13870
C  SUBSEQUENTLY, THE DISTANCES ARE RE-CALCULATED BY MEANS OF SUB-       13880
C  ROUTINE WDIST IN WHICH THE FREQUENCIES ARE WEIGHTED ACCORDING TO     13890
C  SAMPLE SIZE.   ALL REMAINING OPTIONS WILL USE THE RESULTS OF WDIST   13900
C  AND NOT THOSE OF THE PRESENT SIMPLE TECHNIQUE (DIST).                13910
C                                                                       13920
C  ACCEPTS:  LLL   = 0,  IF RESULTS ARE NOT TO BE PRINTED;              13930
C                     OTHERWISE,  RESULTS WILL BE PRINTED.              13940
C                                                                       13950
C  RETURNS:  QDAR  - CUMULATIVE FOSSIL DISTANCES.  SENT TO ORDER()      13960
C            MPAIR - FOR WDIST()                                        13970
C                                                                       13980
C  CALLED IN MAIN PROGRAMME                                             13990
C                                                                       14000
      PARAMETER (KDIM1=25, KDIM3=120, KDIM4=280, KDIM5=10, KDIM6=145)   14010
      PARAMETER (MAXCYC=300, MAXUQ=20)                                  14020
      COMMON N, NS, MMAX, X(KDIM1,KDIM3), ICODE(KDIM4), IRCODE(KDIM4),  14030
     +       C(KDIM6,KDIM6)                                             14040
      DIMENSION MPAIR(KDIM6+MAXUQ), QDAR(KDIM6+MAXUQ)                   14050
      DATA  BOUND/3.0/                                                  14060
C                                                                       14070
      QDAR(1) = 0.0                                                     14080
      NMAX = MMAX - 1                                                   14090
      IF (LLL.EQ.0) GO TO 10                                            14100
          WRITE (6,1000)                                                14110
          WRITE (6,1010)                                                14120
          WRITE (6,1020)                                                14130
 1000     FORMAT (//' UNWEIGHTED DISTANCE ANALYSIS'//)                  14140
 1010     FORMAT (2X, 'POSITION   FOSSIL     FOSSIL     CUMULATIVE',    14150
     +     '   SUM DIFF   NO.')                                         14160
 1020     FORMAT (13X, 'PAIRS     DISTANCE     DISTANCE    Z VALUES',   14170
     +     '   PAIRS'/)                                                 14180
   10 CONTINUE                                                          14190
      DO 100 I = 1,NMAX                                                 14200
          RCONT = 0.0                                                   14210
          SDIFF = 0.0                                                   14220
          ISTP = 0                                                      14230
          K = I - 1                                                     14240
   20     IF (K.EQ.0) GO TO 40                                          14250
C                                                                       14260
C      CASE:  K .LT. I                                                  14270
C             EXAMINE 2 ELEMENTS IN SAME ROW, DIFFERENT COLUMN          14280
C             RCOL1, RCOL2  -  TEMPORARY VARIABLES                      14290
C                                                                       14300
              RCOL1 = C(K,I)                                            14310
              RCOL2 = C(K,I+1)                                          14320
              IF (RCOL1.LT.-BOUND .OR. RCOL1.GT.BOUND) GO TO 30         14330
              IF (RCOL2.LT.-BOUND .OR. RCOL2.GT.BOUND) GO TO 30         14340
              RCONT = RCONT + 1.0                                       14350
              IF (RCOL1.EQ.AAA .AND. RCOL2.EQ.AAA) ISTP = ISTP + 1      14360
              IF (RCOL1.NE.AAA .OR. RCOL2.NE.AAA) ISTP = 0              14370
              IF (ISTP.EQ.5) RCONT = RCONT - 5.0                        14380
              IF (ISTP.EQ.5) GO TO 40                                   14390
              SDIFF = SDIFF + RCOL2 - RCOL1                             14400
   30         K = K - 1                                                 14410
              GO TO 20                                                  14420
C                                                                       14430
C  CASE:  K .EQ. I    (SPECIAL CASE)                                    14440
C                                                                       14450
   40     IF (ISTP.GT.0 .AND. ISTP.LT.5) RCONT = RCONT - ISTP           14460
          CAA = C(I,I+1)                                                14470
          IF (CAA.GE.-AAA .AND. CAA.LE.AAA) SDIFF = SDIFF + CAA         14480
          IF (CAA.GE.-AAA .AND. CAA.LE.AAA) RCONT = RCONT + 1.0         14490
          ISTP = 0                                                      14500
          K = I + 2                                                     14510
C                                                                       14520
C  CASE:  K .GT. I                                                      14530
C         DIFFERENT ROW, SAME COLUMN                                    14540
C                                                                       14550
   50     IF (K.GT.MMAX) GO TO 70                                       14560
               RCOL1 = C(I,K)                                           14570
               RCOL2 = C(I+1,K)                                         14580
               IF (RCOL1.LT.-BOUND .OR. RCOL1.GT.BOUND) GO TO 60        14590
               IF (RCOL2.LT.-BOUND .OR. RCOL2.GT.BOUND) GO TO 60        14600
               RCONT = RCONT + 1.0                                      14610
               IF (RCOL1.EQ.AAA .AND. RCOL2.EQ.AAA) ISTP = ISTP + 1     14620
               IF (RCOL1.NE.AAA .OR. RCOL2.NE.AAA) ISTP = 0             14630
               IF (ISTP.EQ.5) RCONT = RCONT - 5.0                       14640
               IF (ISTP.EQ.5) GO TO 70                                  14650
               RDIFF = RCOL1 - RCOL2                                    14660
               SDIFF = SDIFF + RDIFF                                    14670
   60          CONTINUE                                                 14680
               K = K + 1                                                14690
               GO TO 50                                                 14700
   70     IF (ISTP.GT.0 .AND. ISTP.LT.5) RCONT = RCONT - ISTP           14710
          IF (RCONT.EQ.0.0) GO TO 80                                    14720
          QDIFF = SDIFF / RCONT                                         14730
          GO TO 90                                                      14740
   80     QDIFF = 0.0                                                   14750
   90     QDAR(I+1) = QDAR(I) + QDIFF                                   14760
          MPAIR(I) = INT (RCONT)                                        14770
          IF (LLL.EQ.0) GO TO 100                                       14780
          WRITE (6,2000) I, IRCODE(I), IRCODE(I+1), QDIFF, QDAR(I+1),   14790
     +      SDIFF, RCONT                                                14800
 2000     FORMAT (1X, I8, I5, '-', I3, F11.4, F13.4, F13.2, F7.0)       14810
  100 CONTINUE                                                          14820
      RETURN                                                            14830
      END                                                               14840
      SUBROUTINE ECHO                                                   14850
C                                                                       14860
C ... SUBROUTINE TO PRINT OUT ALL THE SEQUENCE DATA                     14870
C                                                                       14880
C  CALLED IN MAIN PROGRAMME, SUBROUTINES HPFILT AND PRESRT              14890
C                                                                       14900
      PARAMETER (KDIM1=25, KDIM3=120, KDIM4=280, KDIM5=10, KDIM6=145)   14910
      COMMON  N, NS, MMAX, IDATA(KDIM1,KDIM3), MM(KDIM4), M(KDIM4),     14920
     +        RMAT(KDIM6,KDIM6)                                         14930
      COMMON /TEXT/ NAME(KDIM1,5), ITITLE(KDIM4,10)                     14940
      CHARACTER*4  NAME, ITITLE                                         14950
C                                                                       14960
      DO 30 I = 1,NS                                                    14970
          ILIMIT = 0                                                    14980
          DO 10 J = 1,KDIM3                                             14990
              IF (IDATA(I,J).EQ.0)  GO TO 20                            15000
              ILIMIT = ILIMIT + 1                                       15010
   10     CONTINUE                                                      15020
   20     WRITE (6,1000) (NAME(I,J), J = 1,5)                           15030
 1000     FORMAT (///2X, 5A4)                                           15040
          WRITE (6,2000) (IDATA(I,J), J = 1,ILIMIT)                     15050
 2000     FORMAT (20I5)                                                 15060
   30 CONTINUE                                                          15070
      RETURN                                                            15080
      END                                                               15090
      SUBROUTINE FTOZ (P,ZP)                                            15100
C                                                                       15110
C ... SUBROUTINE TO COMPUTE Z FROM FREQUENCY.   EQ. 26.2.23   IN        15120
C                                                                       15130
C      ABRAMOWITZ, M. AND STEGUN, I.A.     (EDITORS)                    15140
C      "HANDBOOK OF MATHEMATICAL FUNCTIONS                              15150
C         WITH FORMULAS, GRAPHS, AND MATHEMATICAL TABLES"               15160
C      PUB. BY NATIONAL BUREAU OF STANDARDS OF THE                      15170
C         U.S. DEPARTMENT OF COMMERCE,   1964.                          15180
C                                                                       15190
C  CALLED BY SUBROUTINE NORMZ                                           15200
C                                                                       15210
      DATA  C0/2.515517/, C1/0.802853/, C2/0.010328/,                   15220
     +      D1/1.432788/, D2/0.189269/, D3/0.001308/                    15230
C                                                                       15240
      Q = P                                                             15250
      IF (P.GT.0.5)  Q = 1.0 - P                                        15260
      TT = ALOG (1.0 / (Q * Q))                                         15270
      T = SQRT (TT)                                                     15280
      UP = C0 + (C1 * T) + (C2 * T * T)                                 15290
      DN = 1.0 + (D1 * T) + (D2 * T * T) + (D3 * T**3)                  15300
      ZP = T - (UP / DN)                                                15310
      IF (P.LE.0.5)  ZP = -ZP                                           15320
      RETURN                                                            15330
      END                                                               15340
      SUBROUTINE HPFILT (IC,IOCR,INIQ,IOMAT)                            15350
C                                                                       15360
C ... SUBROUTINE HPFILT REMOVES FROM THE DATA SET ALL EVENTS WHICH DO   15370
C  DO NOT OCCUR AT LEAST "IOCR" TIMES AND RECODES THE MODIFIED DATA     15380
C  WITH CODE NUMBERS RUNNING FROM 1 TO MMAX                             15390
C                                                                       15400
C  ACCEPTS:  IC    - ORIGINAL SEQUENCE DATA                             15410
C            M     - THE OCCURRENCE TABULATION                          15420
C                                                                       15430
C  RETURNS:  IC    - NOW, THE FILTERED SEQUENCE DATA                    15440
C            ICC   - THE FILTERED, RECODED SEQUENCE DATA                15450
C            MMAX  - NUMBER OF DIFFERENT FOSSILS REMAINING              15460
C                                                                       15470
C  CALLED IN MAIN PROGRAMME                                             15480
C                                                                       15490
      PARAMETER (KDIM1=25, KDIM3=120, KDIM4=280, KDIM5=10, KDIM6=145)   15500
      PARAMETER (MAXCYC=300, MAXUQ=20)                                  15510
      COMMON  N, NS, MMAX, ICC(KDIM1,KDIM3), MM(KDIM4), M(KDIM4),       15520
     +        RMAT(KDIM6,KDIM6)                                         15530
      COMMON /BETA/ IUNIQ(KDIM4,2), NUNIQ(KDIM1), MUNIQ(KDIM1,MAXUQ*2)  15540
      COMMON /TEXT/ NAME(KDIM1,5), ITITLE(KDIM4,10)                     15550
      INTEGER IC(KDIM1,KDIM3)                                           15560
      CHARACTER*4  NAME, ITITLE                                         15570
C                                                                       15580
      DO 30 I = 1,NS                                                    15590
          DO 10 J = 1,KDIM3                                             15600
              ICC(I,J) = 0                                              15610
   10     CONTINUE                                                      15620
          IF (INIQ.NE.1) GO TO 30                                       15630
          DO 20 J = 1,40                                                15640
              MUNIQ(I,J) = 0                                            15650
   20     CONTINUE                                                      15660
   30 CONTINUE                                                          15670
C                                                                       15680
C  ELIMINATE EVENTS WHICH OCCUR FEWER THAN "IOCR" TIMES                 15690
C                                                                       15700
      DO 60 I = 1,NS                                                    15710
          INDIC = 0                                                     15720
          K = 1                                                         15730
          DO 50 J = 1,KDIM3                                             15740
              ID = IC(I,J)                                              15750
              IF (ID.EQ.0) GO TO 60                                     15760
              IDA = IABS (ID)                                           15770
              IF (INIQ.EQ.1 .AND. IUNIQ(IDA,1).EQ.1) M(IDA) = 0         15780
              IF (M(IDA).LT.IOCR) GO TO 40                              15790
              IF (INDIC.EQ.1 .AND. ID.LT.0) ID = ID * (-1)              15800
              ICC(I,K) = ID                                             15810
              K = K + 1                                                 15820
              INDIC = 0                                                 15830
              GO TO 50                                                  15840
   40         IF (ID.GT.0 .AND. INDIC.EQ.0) INDIC = 1                   15850
   50     CONTINUE                                                      15860
   60 CONTINUE                                                          15870
      WRITE (6,1000)                                                    15880
 1000 FORMAT (//////'   SEQUENCE DATA MODIFIED TO INCLUDE ONLY')        15890
      WRITE (6,1010) IOCR                                               15900
 1010 FORMAT ('   THOSE EVENTS WHICH OCCUR AT LEAST',I3,' TIMES')       15910
      CALL ECHO                                                         15920
C  SEND ICC TO ECHO() VIA BLANK COMMON                                  15930
C                                                                       15940
C  PREPARE TABLES TO BE USED IN RECODING                                15950
C                                                                       15960
      DO 70 I = 1,N                                                     15970
          M(I) = 0                                                      15980
          MM(I) = 0                                                     15990
   70 CONTINUE                                                          16000
      DO 90 I = 1,NS                                                    16010
          DO 80 J = 1,KDIM3                                             16020
              ID = ICC(I,J)                                             16030
              IF (ID.EQ.0) GO TO 90                                     16040
              IDA = IABS (ID)                                           16050
              M(IDA) = M(IDA) + 1                                       16060
   80     CONTINUE                                                      16070
   90 CONTINUE                                                          16080
      IF (IOMAT.EQ.1) WRITE (6,1020)                                    16090
 1020 FORMAT (////'   RECODE REFERENCE TABLE, OLD CODE VS. NEW CODE')   16100
C  "M" IS USED AS WORK-AREA FOR THE RECODING TABLE                      16110
      K = 1                                                             16120
      DO 100 I = 1,N                                                    16130
          ID = M(I)                                                     16140
          IF (ID.EQ.0) GO TO 100                                        16150
          M(I) = K                                                      16160
          IF (IOMAT.EQ.1) WRITE(6,1030) I, K                            16170
 1030     FORMAT (2I6)                                                  16180
          MM(K) = I                                                     16190
          K = K + 1                                                     16200
  100 CONTINUE                                                          16210
      IF (INIQ.NE.1) GO TO 120                                          16220
      DO 110 I = 1,NS                                                   16230
          IF (NUNIQ(I).EQ.1) CALL XUNIQ1 (I,IC)                         16240
  110 CONTINUE                                                          16250
C                                                                       16260
C     MAKE A COPY OF THE FILTERED DATA SET BEFORE RECODING.             16270
C          (DESTROY THE UN-FILTERED DATA SET)                           16280
C                                                                       16290
  120 DO 128 I = 1,NS                                                   16300
          DO 125 J = 1,KDIM3                                            16310
              IC(I,J) = ICC(I,J)                                        16320
  125     CONTINUE                                                      16330
  128 CONTINUE                                                          16340
C                                                                       16350
C  PERFORM RECODING                                                     16360
C                                                                       16370
      MMAX = K - 1                                                      16380
      DO 140 I = 1,NS                                                   16390
          DO 130 J = 1,KDIM3                                            16400
              ID = ICC(I,J)                                             16410
              IF (ID.EQ.0) GO TO 140                                    16420
              IDA = IABS (ID)                                           16430
              IDD = M(IDA)                                              16440
              IF (ID.LT.0) IDD = IDD * (-1)                             16450
              ICC(I,J) = IDD                                            16460
  130     CONTINUE                                                      16470
  140 CONTINUE                                                          16480
      WRITE (6,1040)                                                    16490
 1040 FORMAT (////'   RECODED SEQUENCE DATA')                           16500
C  AGAIN, SEND ICC TO ECHO()                                            16510
      CALL ECHO                                                         16520
      IF (IOMAT.NE.1)  GO TO 170                                        16530
          WRITE (6,1050)                                                16540
 1050     FORMAT (///'   CROSS REFERENCE TABLE, NEW CODE VS. OLD CODE') 16550
C  "MM" IS A SERIAL LIST OF OLD CODE NUMBERS                            16560
          DO 160 I = 1,MMAX                                             16570
              WRITE (6,1060) I, MM(I)                                   16580
 1060         FORMAT (2I6)                                              16590
  160     CONTINUE                                                      16600
  170 WRITE (6,1070) MMAX                                               16610
 1070 FORMAT (////'    NUMBER OF FOSSILS RETAINED:',I5)                 16620
      WRITE (7,1071) MMAX                                               16630
 1071 FORMAT (I10)                                                      16640
C                                                                       16650
      IF (MMAX.GT.1 .AND. MMAX.LT.KDIM6)  GO TO 999                     16660
      IF (MMAX.GT.KDIM6)  GO TO 220                                     16670
          WRITE (6,1075)                                                16680
 1075     FORMAT (///1X, '*** ERROR:  TOO MUCH FILTERING DONE --',      16690
     +      ' NO DATA LEFT'/16X, 'RECOMMENDED ACTION: DECREASE',        16700
     +      ' VALUE OF "IOCR"')                                         16710
          WRITE (6,1090)                                                16720
          STOP                                                          16730
  220 WRITE (6,1080) KDIM6                                              16740
 1080     FORMAT (///1X,'*** ERROR:   TOO MANY EVENTS REMAINING  (>',I4,16750
     +      ')', /16X, 'CAUSE:  NOT ENOUGH FILTERING DONE',             16760
     +      /16X, 'RECOMMENDED ACTION:  INCREASE VALUE OF "IOCR" OR',   16770
     +      /36X, 'USE A BIGGER VERSION OF RASC')                       16780
          WRITE (6,1090)                                                16790
 1090     FORMAT (///' *** EXECUTION TERMINATED IN   SUBROUTINE HPFILT')16800
          STOP                                                          16810
C                                                                       16820
  999 RETURN                                                            16830
      END                                                               16840
      SUBROUTINE NORMZ (AAA,LLL,IOMAT)                                  16850
C                                                                       16860
C ... SUBROUTINE TO COMPUTE 'Z' (NORMAL) VALUES OF FREQUENCIES          16870
C                                                                       16880
C      C(I,J)                                                           16890
C  ---------------     FROM CUMULATIVE ORDER MATRIX.                    16900
C  C(I,J) + C(J,I)                                                      16910
C                                                                       16920
C  ACCEPTS:  C  - CUMULATIVE ORDER MATRIX                               16930
C  RETURNS:  UPPER TRIANGLE OF "C", EXCLUDING THE MAIN DIAGONAL         16940
C                                                                       16950
C  CALLED IN MAIN PROGRAMME.                                            16960
C                                                                       16970
      PARAMETER (KDIM1=25, KDIM3=120, KDIM4=280, KDIM5=10, KDIM6=145)   16980
      COMMON N, NS,MMAX, IX(KDIM1,KDIM3), ICODE(KDIM4), IRCODE(KDIM4),  16990
     +       C(KDIM6,KDIM6)                                             17000
      DATA  CONST/9.0/, TAILL/0.05/, TAILR/0.95/                        17010
C                                                                       17020
      DO 40 I = 1,MMAX                                                  17030
          K = I + 1                                                     17040
          DO 30 J = K,MMAX                                              17050
              RCL1 = C(I,J)                                             17060
              RCL2 = C(J,I)                                             17070
              SRCL = RCL1 + RCL2                                        17080
              IF (SRCL.EQ.0.0) GO TO 20                                 17090
              QRCL = RCL1 / SRCL                                        17100
              IF (QRCL.LE.0.0 .OR. QRCL.GE.1.0)  GO TO 10               17110
              CALL FTOZ (QRCL,QX)                                       17120
              C(I,J) = QX                                               17130
              GO TO 30                                                  17140
   10         IF (QRCL.EQ.1.0) C(I,J) = AAA                             17150
              IF (QRCL.EQ.1.0) C(J,I) = TAILL * SRCL                    17160
              IF (QRCL.EQ.0.0) C(I,J) = -AAA                            17170
              IF (QRCL.EQ.0.0) C(J,I) = TAILR * SRCL                    17180
              GO TO 30                                                  17190
   20         C(I,J) = CONST                                            17200
   30     CONTINUE                                                      17210
   40 CONTINUE                                                          17220
      IF (LLL.EQ.0 .OR. IOMAT.NE.1)  GO TO 60                           17230
      WRITE (6,1000)                                                    17240
 1000 FORMAT (////'  UPPER TRIANGLE OF NORMAL Z VALUES')                17250
      DO 50 I = 1,MMAX                                                  17260
          WRITE (6,1001)                                                17270
 1001     FORMAT (///)                                                  17280
          WRITE (6,1002) (C(I,J), J = 1,MMAX)                           17290
 1002     FORMAT (1X, 15F8.3)                                           17300
   50 CONTINUE                                                          17310
   60 RETURN                                                            17320
      END                                                               17330
      SUBROUTINE OCCTAB                                                 17340
C                                                                       17350
C ... SUBROUTINE TO PRINT A SUMMARY TABLE SHOWING HOW MANY TIMES AN     17360
C  EVENT APPEARS IN THE DATA SET AS A WHOLE.                            17370
C  ACCEPTS:  M(KDIM4)  -  TALLY OF DICTIONARY EVENTS  (FROM M/PROG)     17380
C                                                                       17390
C  CALLED IN MAIN PROGRAMME.                                            17400
C                                                                       17410
      PARAMETER (KDIM1=25, KDIM3=120, KDIM4=280, KDIM5=10, KDIM6=145)   17420
      COMMON  N, NS, MMAX, ICC(KDIM1,KDIM3), ICODE(KDIM4), M(KDIM4),    17430
     +        RMAT(KDIM6,KDIM6)                                         17440
      INTEGER ICOL(10), MCUM(25), MM(25)                                17450
      DATA    NCOLS/6/                                                  17460
C                                                                       17470
      WRITE (6,1000)                                                    17480
      WRITE (6,2000)                                                    17490
      WRITE (6,3000)                                                    17500
 1000 FORMAT (1H1,'TABULATION OF EVENT OCCURRENCES')                    17510
 2000 FORMAT (' DICTIONARY CODE NUMBER VERSUS FREQUENCY OF OCCURRENCE') 17520
 3000 FORMAT (////)                                                     17530
C     NROWS = SMALLEST INTEGER .GE. (N / FLOAT(NCOLS))                  17540
      NROWS = INT ((N / FLOAT (NCOLS)) + 0.99)                          17550
      II = 1                                                            17560
    3 ICOL(NCOLS) = (NCOLS - 1) * NROWS + II                            17570
      IF (ICOL(NCOLS).GT.N)  GO TO 10                                   17580
          DO 5 IND = 1,NCOLS                                            17590
              ICOL(IND) = (IND - 1) * NROWS + II                        17600
    5     CONTINUE                                                      17610
          WRITE (6,4000) (ICOL(K), M(ICOL(K)), K = 1,NCOLS)             17620
 4000     FORMAT (9('  *  ', 2I5))                                      17630
          II = II + 1                                                   17640
          GO TO 3                                                       17650
   10 CONTINUE                                                          17660
      IF (II.GT.NROWS)  GO TO 17                                        17670
          DO 15 J = II,NROWS                                            17680
              NEWCOL = NCOLS - 1                                        17690
              DO 13 IND = 1,NEWCOL                                      17700
                  ICOL(IND) = (IND - 1) * NROWS + J                     17710
   13         CONTINUE                                                  17720
              WRITE (6,4000) (ICOL(K), M(ICOL(K)), K = 1,NEWCOL)        17730
   15     CONTINUE                                                      17740
C                                                                       17750
   17 DO 20 I = 1,NS                                                    17760
          MM(I) = 0                                                     17770
   20 CONTINUE                                                          17780
      DO 35 J = 1,N                                                     17790
         IF (M(J).GT.NS)  GO TO 8000                                    17800
         IF (M(J).GT.0)  MM(M(J)) = MM(M(J)) + 1                        17810
   35 CONTINUE                                                          17820
      MCUM(NS) = MM(NS)                                                 17830
C                                                                       17840
C  CUMULATE EVENT SEQUENCE                                              17850
C                                                                       17860
      DO 50 J = 2,NS                                                    17870
          I = NS + 1 - J                                                17880
          MCUM(I) = MCUM(I+1) + MM(I)                                   17890
   50 CONTINUE                                                          17900
      WRITE (6,1000)                                                    17910
C LET IEND = SMALLEST INTEGER .GE. (NS/25.0)                            17920
      IEND = INT (NS / 25.0 + 0.99)                                     17930
      DO 60 I = 1,IEND                                                  17940
          JSTART = (25 * I) - 24                                        17950
          JEND = NS                                                     17960
          IF (I.LT.IEND)  JEND = JSTART + 24                            17970
          WRITE (6,5000) (J, J = JSTART,JEND)                           17980
 5000     FORMAT (//3X, 'NUMBER OF WELLS  ', 25I4)                      17990
          WRITE (6,6000) (MM(J), J = JSTART,JEND)                       18000
 6000     FORMAT (3X, 'NUMBER OF EVENTS ', 25I4)                        18010
          WRITE (6,7000) (MCUM(J), J = JSTART,JEND)                     18020
 7000     FORMAT (3X, 'CUMULATIVE NUMBER', 25I4)                        18030
   60 CONTINUE                                                          18040
      RETURN                                                            18050
C                                                                       18060
 8000 WRITE (6,8200) J, M(J)                                            18070
 8200 FORMAT (//' *** ERROR -  TOO MANY OCCURRENCES.',                  18080
     +  /15X, 'FOSSIL',I4,' OCCURS',I4,' TIMES, WHICH IS MORE THAN',    18090
     +  ' THE NUMBER OF WELLS IN THE DATA SET')                         18100
      WRITE (6,8210)                                                    18110
 8210 FORMAT (/' NOTE THAT A FOSSIL MUST NOT BE RECORDED MORE THAN',    18120
     +  ' ONCE IN ANY WELL')                                            18130
      WRITE (6,8220)                                                    18140
 8220 FORMAT (///' *** EXECUTION TERMINATED IN   SUBROUTINE OCCTAB')    18150
      STOP                                                              18160
C                                                                       18170
      END                                                               18180
      SUBROUTINE ORDER (QDAR,IPAIR,XLEV,LLL,LOUT)                       18190
C                                                                       18200
C ... SUBROUTINE ORDER IS A SUPPORT ROUTINE FOR DISTANCE CALCULATIONS   18210
C  TO RE-ORDER THE OPTIMUM SEQUENCE ON THE BASIS OF CUMULATIVE          18220
C  INTER-EVENT "DISTANCES".                                             18230
C                                                                       18240
C  ACCEPTS:  MMAX   - NUMBER OF EVENTS TO BE CONSIDERED                 18250
C                     (NUMBER OF FOSSILS REMAINING AFTER FILTERING)     18260
C            QDAR   - CUMULATIVE INTERFOSSIL DISTANCES.                 18270
C                     FROM DIST(), WDIST(), AND COMP()                  18280
C            IRCODE - THE CURRENT OPTIMUM SEQUENCE                      18290
C                                                                       18300
C  RETURNS:  QDAR   - SORTED IN ASCENDING ORDER                         18310
C            IRCODE - OPTIMUM SEQUENCE RE-ORDERED ON THE BASIS OF       18320
C                       ASCENDING QDAR (THE CUMULATIVE DISTANCES)       18330
C            IPAIR(2,*)  - (FOR USE IN DENDRO())                        18340
C            XLEV(*)     - (FOR USE IN DENDRO())                        18350
C                                                                       18360
C  CALLED IN MAIN PROGRAMME.   (MANY TIMES NEAR THE END)                18370
C                                                                       18380
      PARAMETER (KDIM1=25, KDIM3=120, KDIM4=280, KDIM5=10, KDIM6=145)   18390
      PARAMETER (MAXCYC=300, MAXUQ=20)                                  18400
      COMMON  N, NS,MMAX, IX(KDIM1,KDIM3), ICODE(KDIM4), IRCODE(KDIM4), 18410
     +        C(KDIM6,KDIM6)                                            18420
      INTEGER IPAIR(2,KDIM6+MAXUQ)                                      18430
      REAL    QDAR(KDIM6+MAXUQ), XLEV(KDIM6+MAXUQ)                      18440
C                                                                       18450
C  SORT CUMULATIVE 'DISTANCES' IN ASCENDING ORDER                       18460
C                                                                       18470
      NMAX = MMAX - 1                                                   18480
      QDAR(1) = 0.0                                                     18490
   10 KFLAG = 0                                                         18500
      DO 20 I = 1,NMAX                                                  18510
          SORT1 = QDAR(I)                                               18520
          SORT2 = QDAR(I+1)                                             18530
          IF (SORT1.LE.SORT2) GO TO 20                                  18540
              QDAR(I) = SORT2                                           18550
              QDAR(I+1) = SORT1                                         18560
              ITEMP = IRCODE(I)                                         18570
              IRCODE(I) = IRCODE(I+1)                                   18580
              IRCODE(I+1) = ITEMP                                       18590
              KFLAG = 1                                                 18600
   20 CONTINUE                                                          18610
      IF (KFLAG.GE.1) GO TO 10                                          18620
      DO 30 I = 1,NMAX                                                  18630
          IPAIR(1,I) = IRCODE(I)                                        18640
          IPAIR(2,I) = IRCODE(I+1)                                      18650
          XLEV(I) = QDAR(I+1) - QDAR(I)                                 18660
   30 CONTINUE                                                          18670
      XLEV(MMAX) = 0.0                                                  18680
      IF (LLL.EQ.0) GO TO 50                                            18690
          WRITE (6,1000)                                                18700
          IF (LOUT.EQ.1) WRITE (6,1010)                                 18710
 1010         FORMAT (5X, 'NOTE:  IN ORDER TO RECALCULATE STANDARD',    18720
     +        ' DEVIATIONS AFTER SORTING, DISTANCE VALUES MUST BE',     18730
     +        ' RECALCULATED'//)                                        18740
          WRITE (6,1001)                                                18750
          WRITE (6,1002)                                                18760
          WRITE (6,1003)                                                18770
 1000     FORMAT (///1X, 'EVENTS ARE SORTED ON THE BASIS OF CUMULATIVE',18780
     +     ' DISTANCE TO OBTAIN ONLY POSITIVE INTERFOSSIL DISTANCES'/)  18790
 1001     FORMAT (' NEW        DISTANCE       FOSSIL    INTER')         18800
 1002     FORMAT (' SEQUENCE   FROM 1ST       PAIRS     FOSSIL')        18810
 1003     FORMAT ('            POSITION                 DISTANCE'/)     18820
          DO 40 I = 1,NMAX                                              18830
              WRITE (6,1004) IRCODE(I),QDAR(I),IRCODE(I),IRCODE(I+1),   18840
     +          QDAR(I+1)-QDAR(I)                                       18850
 1004         FORMAT (1X, I4, F13.4, I10, '-', I3, F10.4)               18860
   40     CONTINUE                                                      18870
          WRITE (6,1005) IRCODE(MMAX), QDAR(MMAX)                       18880
 1005     FORMAT (1X, I4, F13.4)                                        18890
   50     RETURN                                                        18900
      END                                                               18910
      SUBROUTINE PRESRT (IOMAT)                                         18920
C                                                                       18930
C ... SUBROUTINE FOR PRELIMINARY SEQUENCING OF THE DATA IN ORDER TO     18940
C  OBTAIN AN OPTIMIZED STARTING SEQUENCE                                18950
C                                                                       18960
C  ACCEPTS:  MMAX  - NUMBER OF DIFFERENT FOSSILS REMAINING AFTER        18970
C                      FILTERING.  (FROM HPFILT())                      18980
C            ICC   - FILTERED, RECODED SEQUENCE DATA                    18990
C  RETURNS:  RMAT                                                       19000
C                                                                       19010
C  CALLED IN MAIN PROGRAMME                                             19020
C                                                                       19030
      PARAMETER (KDIM1=25, KDIM3=120, KDIM4=280, KDIM5=10, KDIM6=145)   19040
      COMMON N, NS, MMAX, ICC(KDIM1,KDIM3), MM(KDIM4), IGAD(KDIM4),     19050
     +       RMAT(KDIM6,KDIM6)                                          19060
      DIMENSION MP(KDIM6,3), SCORE(KDIM6,2)                             19070
C                                                                       19080
C  CREATE AN ORDER RELATION MATRIX                                      19090
C                                                                       19100
      WRITE (6,1000)                                                    19110
 1000 FORMAT (1H1,' PRESORT OPTION INITIATED')                          19120
      IF (IOMAT.EQ.1) WRITE (6,1010)                                    19130
 1010 FORMAT (///' CUMULATIVE ORDER MATRIX'///)                         19140
      DO 20 I = 1,MMAX                                                  19150
          DO 10 J = 1,MMAX                                              19160
              RMAT(I,J) = 0.0                                           19170
   10     CONTINUE                                                      19180
   20 CONTINUE                                                          19190
C                                                                       19200
C  ITEST   = 0,  IF IKK IS FOUND ON THE SAME LEVEL OF THE WELL AS       19210
C                 IAA  (OUR REFERENCE FOSSIL)                           19220
C                                                                       19230
      DO 60 L = 1,NS                                                    19240
          DO 50 J = 1,MMAX                                              19250
              ITEST = 0                                                 19260
              K = J                                                     19270
              ID = ICC(L,K)                                             19280
              IF (ID.EQ.0) GO TO 60                                     19290
              I = IABS (ID)                                             19300
   30         K = K + 1                                                 19310
              IF (K.GT.KDIM3)  GO TO 50                                 19320
              IAA = ICC(L,K)                                            19330
              IF (IAA.EQ.0) GO TO 50                                    19340
              IKK = IABS (IAA)                                          19350
              IF (IAA.LT.0 .AND. ITEST.LE.0) GO TO 40                   19360
                  ITEST = 1                                             19370
                  RMAT(I,IKK) = RMAT(I,IKK) + 1.0                       19380
                  GO TO 30                                              19390
   40         RMAT(I,IKK) = RMAT(I,IKK) + 0.5                           19400
                  RMAT(IKK,I) = RMAT(IKK,I) + 0.5                       19410
                  GO TO 30                                              19420
   50     CONTINUE                                                      19430
   60 CONTINUE                                                          19440
      DO 70 I = 1,MMAX                                                  19450
          SCORE(I,2) = 0.0                                              19460
          IF (IOMAT.EQ.1) WRITE (6,1020) (RMAT(I,J), J = 1,MMAX)        19470
 1020     FORMAT (20F5.1)                                               19480
   70 CONTINUE                                                          19490
C                                                                       19500
C  CALCULATE FOSSIL SCORES                                              19510
C                                                                       19520
      DO 90 I = 1,MMAX                                                  19530
          RCOUNT = 0.0                                                  19540
          DO 80 J = 1,MMAX                                              19550
              IF (I.EQ.J) GO TO 80                                      19560
              REL1 = RMAT(I,J)                                          19570
              REL2 = RMAT(J,I)                                          19580
              IF (REL1.EQ.0.0 .AND. REL2.EQ.0.0) GO TO 80               19590
              RCOUNT = RCOUNT + 1.0                                     19600
              FREQ = REL1 / (REL1 + REL2)                               19610
              IF (FREQ.LT.0.5) FREQ = 0.0                               19620
              IF (FREQ.GT.0.5) FREQ = 1.0                               19630
              SCORE(I,2) = SCORE(I,2) + FREQ                            19640
   80     CONTINUE                                                      19650
          SCORE(I,2) = SCORE(I,2) * (MMAX - 1) / RCOUNT                 19660
   90 CONTINUE                                                          19670
      IF (IOMAT.EQ.1) WRITE (6,1030)                                    19680
 1030 FORMAT (///' CODE FOLLOWED BY SCORE')                             19690
C                                                                       19700
C  SCORE(*,2)  -  FIRST COLUMN: (ESSENTIALLY INTEGER) THE POSITIONS     19710
C                SECOND COLUMN: THE PRESORTING SCORES                   19720
C                                                                       19730
      Z = 1.0                                                           19740
      DO 100 I = 1,MMAX                                                 19750
          SCORE(I,1) = Z                                                19760
          Z = Z + 1                                                     19770
          IF (IOMAT.EQ.1) WRITE (6,1040) SCORE(I,1), SCORE(I,2)         19780
 1040     FORMAT (2F10.1)                                               19790
  100 CONTINUE                                                          19800
C                                                                       19810
C  SORT THE SCORES IN DESCENDING ORDER                                  19820
C                                                                       19830
      MM1 = MMAX - 1                                                    19840
      DO 120 I = 1,MM1                                                  19850
          MM2 = I + 1                                                   19860
          DO 110 J = MM2,MMAX                                           19870
              IF (SCORE(I,2).GE.SCORE(J,2)) GO TO 110                   19880
              TEMP2 = SCORE(I,2)                                        19890
              SCORE(I,2) = SCORE(J,2)                                   19900
              SCORE(J,2) = TEMP2                                        19910
              TEMP1 = SCORE(I,1)                                        19920
              SCORE(I,1) = SCORE(J,1)                                   19930
              SCORE(J,1) = TEMP1                                        19940
  110     CONTINUE                                                      19950
  120 CONTINUE                                                          19960
      IF (IOMAT.EQ.1) WRITE (6,1050)                                    19970
 1050 FORMAT (///' SCORES IN DESCENDING ORDER')                         19980
      DO 130 I = 1,MMAX                                                 19990
          IF (IOMAT.EQ.1) WRITE (6,1040) SCORE(I,1), SCORE(I,2)         20000
  130 CONTINUE                                                          20010
C                                                                       20020
C                                                                       20030
      IF (IOMAT.EQ.1) WRITE (6,1060)                                    20040
 1060 FORMAT (///' NEW CROSS REFERENCE TABLE')                          20050
      DO 140 I = 1,MMAX                                                 20060
          MP(I,1) = I                                                   20070
          MP(I,2) = MM(I)                                               20080
          MP(I,3) = INT (SCORE(I,1))                                    20090
          IF (IOMAT.EQ.1) WRITE (6,1070) MP(I,1), MP(I,3)               20100
 1070     FORMAT (1X, 2I6)                                              20110
  140 CONTINUE                                                          20120
C                                                                       20130
C  CONSTRUCT A NEW CODE REFERENCE TABLE                                 20140
C                                                                       20150
      DO 150 I = 1,MMAX                                                 20160
          ID = MP(I,3)                                                  20170
          MM(I) = MP(ID,2)                                              20180
  150 CONTINUE                                                          20190
C                                                                       20200
C  SORT THE NEW ORDER                                                   20210
C                                                                       20220
      DO 180 I = 1,MM1                                                  20230
          MM2 = I + 1                                                   20240
          DO 170 J = MM2,MMAX                                           20250
              IF (MP(J,3).GT.MP(I,3)) GO TO 170                         20260
              DO 160 K = 1,3                                            20270
                  ITEMP = MP(I,K)                                       20280
                  MP(I,K) = MP(J,K)                                     20290
                  MP(J,K) = ITEMP                                       20300
  160         CONTINUE                                                  20310
  170     CONTINUE                                                      20320
  180 CONTINUE                                                          20330
C                                                                       20340
C  RECODE DATA IN PRELIMINARY SEQUENCE                                  20350
C                                                                       20360
      DO 200 I = 1,NS                                                   20370
          DO 190 J = 1,KDIM3                                            20380
              ID = ICC(I,J)                                             20390
              IF (ID.EQ.0) GO TO 200                                    20400
              IDD = MP(IABS(ID), 1)                                     20410
              IF (ID.LT.0) IDD = IDD * (-1)                             20420
              ICC(I,J) = IDD                                            20430
  190     CONTINUE                                                      20440
  200 CONTINUE                                                          20450
      WRITE (6,3000)                                                    20460
 3000 FORMAT (////'   RECODED AND PRESORTED DATA SET')                  20470
      CALL ECHO                                                         20480
      RETURN                                                            20490
      END                                                               20500
      SUBROUTINE READIN                                                 20510
C                                                                       20520
C ... SUBROUTINE TO READ IN ALL THE INPUT PARAMETERS, SEQUENCE          20530
C  DATA, AND DICTIONARY.                                                20540
C  EXECUTION IS TERMINATED IF ANY ERRORS ARE DISCOVERED.                20550
C                                                                       20560
C  CALLED IN MAIN PROGRAMME                                             20570
C                                                                       20580
      PARAMETER (KDIM1=25, KDIM3=120, KDIM4=280, KDIM5=10, KDIM6=145)   20590
      PARAMETER (MAXCYC=300, MAXUQ=20)                                  20600
      COMMON  N, NS,MMAX, IX(KDIM1,KDIM3), ICODE(KDIM4), IRCODE(KDIM4), 20610
     +        C(KDIM6,KDIM6)                                            20620
      COMMON  /BETA/ IUNIQ(KDIM4,2), NUNIQ(KDIM1), MUNIQ(KDIM1,MAXUQ*2) 20630
      COMMON  /DELTA/ IOCR, INIQ, CRIT1, TOL, AAA, CRIT2, MAX, ITER,    20640
     +        IOMAT, ISRT, IALPHA, ITAB1, ISCORE, ICOMP, ISKIP, IFIN,   20650
     +        INOSC, INEG, ISCAT, TMAT(KDIM1,KDIM3)                     20660
      COMMON  /TEXT/ NAME(KDIM1,5), ITITLE(KDIM4,10)                    20670
      INTEGER ITEM(MAXUQ), TMAT, ITALLY(KDIM4)                          20680
      CHARACTER*4 NAME, ITITLE, ITEMP                                   20690
C                                                                       20700
C  RETURNS THE OBSERVED DATA IN TMAT(*,*) VIA COMMON /DELTA/,           20710
C          AND IN IX(*,*) VIA BLANK COMMON.                             20720
C  IUNIQ(KDIM4, 2)  IS A MAP SHOWING THE UNIQUE EVENTS IN COLUMN 1      20730
C          AND THE MARKER HORIZONS IN COLUMN 2                          20740
C  NUNIQ(KDIM1) IS A MAP SHOWING WHICH SEQUENCES HAVE UNIQUE EVENTS     20750
C                                                                       20760
C  READ THE RUN-PARAMETERS AND THE PROCESSING OPTIONS                   20770
C                                                                       20780
      READ (5,*) NS, IOCR, INIQ, ITER, CRIT1, TOL, AAA, CRIT2           20790
      READ (5,*) ITAPE, IOMAT, ISRT, IALPHA, ITAB1, ISCORE, ICOMP,      20800
     +      ISKIP, IFIN, INOSC, INEG, ISCAT                             20810
      WRITE (6,1040)                                                    20820
      WRITE (6,1041)                                                    20830
      WRITE (6,1042) NS, IOCR, INIQ, ITER, CRIT1, TOL, AAA, CRIT2       20840
      WRITE (6,1045)                                                    20850
      WRITE (6,1046) ITAPE, IOMAT, ISRT, IALPHA, ITAB1, ISCORE, ICOMP,  20860
     +      ISKIP, IFIN, INOSC, INEG, ISCAT                             20870
 1040 FORMAT (///5X, 'VALUES OF INPUT PARAMETERS'//)                    20880
 1041 FORMAT (1X, 'RUN PARAMETERS:    NS IOCR INIQ  ITER  CRIT1   TOL', 20890
     +  6X, 'AAA', 5X, 'CRIT2')                                         20900
 1042 FORMAT (17X, I5, I5, I5, I6, F7.1, F7.1, F11.5, F7.1)             20910
 1045 FORMAT (/1X, 'PROCESSING OP:  ITAPE IOMAT ISRT IALPHA ITAB1',     20920
     +  ' ISCORE ICOMP ISKIP IFIN INOSC INEG ISCAT')                    20930
 1046 FORMAT (18X, I4, I6, I5, I7, I6, I7, I6, I6, I5, I6, I5, I6)      20940
      DO 100 I = 1,KDIM4                                                20950
          IRCODE(I) = 0                                                 20960
          IUNIQ(I,1) = 0                                                20970
          IUNIQ(I,2) = 0                                                20980
  100 CONTINUE                                                          20990
C                                                                       21000
C  READ UNIQUE EVENTS AND MARKER HORIZONS                               21010
C                                                                       21020
      READ 1050, (ITEM(J), J = 1,20)                                    21030
 1050 FORMAT (20I4)                                                     21040
      IF (ITEM(1).EQ.0 .OR. INIQ.EQ.1)  GO TO 1055                      21050
          WRITE (6,1051)                                                21060
 1051     FORMAT (///1X, '** WARNING:  UNIQUE EVENTS FOUND ON RECORD 3' 21070
     +      /15X, '"INIQ" SET EQUAL TO 1')                              21080
          INIQ = 1                                                      21090
 1055 IF (INIQ.EQ.1) WRITE (6,1060)                                     21100
 1060 FORMAT (///' THE FOLLOWING UNIQUE EVENTS HAVE BEEN SELECTED:'/)   21110
      DO 105 I = 1,20                                                   21120
          ID = ITEM(I)                                                  21130
          IF (ID.EQ.0) GO TO 110                                        21140
          IUNIQ(ID,1) = 1                                               21150
          WRITE (6,1070) ID                                             21160
 1070     FORMAT (5X,I4)                                                21170
  105 CONTINUE                                                          21180
  110 READ 1050, (ITEM(J), J = 1,20)                                    21190
      IF (ITEM(1).EQ.0 .OR. INIQ.EQ.1)  GO TO 112                       21200
          WRITE (6,1075)                                                21210
 1075     FORMAT (///1X, '** WARNING:  MARKER HORIZONS FOUND ON RECORD',21220
     +      ' 4'/ 15X, '"INIQ" SET EQUAL TO 1')                         21230
          INIQ = 1                                                      21240
  112 IF (INIQ.EQ.1) WRITE (6,1080)                                     21250
 1080 FORMAT (///' THE FOLLOWING MARKER HORIZONS HAVE BEEN SELECTED:'/) 21260
      DO 115 I = 1,20                                                   21270
          ID = ITEM(I)                                                  21280
          IF (ID.EQ.0) GO TO 120                                        21290
          IUNIQ(ID,2) = 1                                               21300
          WRITE (6,1070) ID                                             21310
  115 CONTINUE                                                          21320
C                                                                       21330
C  PERFORM DATA VALIDATION ON INPUT PARAMETERS                          21340
C                                                                       21350
  120 CALL CHECK (NS,CRIT1,CRIT2,IOCR,IER)                              21360
      IF (IER.NE.0)  STOP                                               21370
C                                                                       21380
C  READ IN THE WELL DATA                                                21390
C                                                                       21400
      DO 130 I = 1,NS                                                   21410
          NUNIQ(I) = 0                                                  21420
          DO 125 J = 1,KDIM3                                            21430
              TMAT(I,J) = 0                                             21440
              IX(I,J) = 0                                               21450
  125     CONTINUE                                                      21460
  130 CONTINUE                                                          21470
      IODATA = 5                                                        21480
      IF (ITAPE.EQ.1) IODATA = 10                                       21490
      DO 135 I = 1,NS                                                   21500
          READ (IODATA,1090) (NAME(I,J), J = 1,5)                       21510
 1090     FORMAT (5A4)                                                  21520
          K = 0                                                         21530
  131     READ (IODATA,1100) (ITEM(J), J = 1,20)                        21540
 1100         FORMAT (20I4)                                             21550
              DO 133 J = 1,20                                           21560
                  ITEMJ = ITEM(J)                                       21570
                  IF (ITEMJ.EQ.-999)  GO TO 134                         21580
                  IF (ITEMJ.EQ.0)  GO TO 133                            21590
                      K = K + 1                                         21600
                      IF (K.LE.KDIM3)  GO TO 132                        21610
                          WRITE (6,1105)                                21620
 1105                     FORMAT (//1X, '*** ERROR:  SEQUENCE TOO LONG',21630
     +                        /12X, 'POSSIBLE CAUSE:  MISSING -999',    21640
     +                        /12X, 'OTHERWISE:  USE A LARGER VERSION', 21650
     +                        ' OF RASC'//' **** EXECUTION TERMINATED'/)21660
                          STOP                                          21670
  132                 TMAT(I,K) = ITEMJ                                 21680
  133         CONTINUE                                                  21690
              GO TO 131                                                 21700
  134     IF (K.LT.KDIM3)  TMAT(I,K+1) = 0                              21710
  135 CONTINUE                                                          21720
C                                                                       21730
C  READ IN THE DICTIONARY                                               21740
C                                                                       21750
      I = 1                                                             21760
      READ (99,5000) (ITITLE(I,J), J = 1,10)                            21770
 5000 FORMAT (10A4)                                                     21780
 5500 IF (ITITLE(I,1).EQ.'LAST' .OR. I.EQ.KDIM4)  GO TO 6000            21790
          I = I + 1                                                     21800
          READ (99,5000) (ITITLE(I,J), J = 1,10)                        21810
          GO TO 5500                                                    21820
 6000 IF (ITITLE(I,1).EQ.'LAST')  GO TO 7000                            21830
          I = I + 1                                                     21840
          READ (99,5000) ITEMP                                          21850
          IF (ITEMP.EQ.'LAST')  GO TO 7000                              21860
              WRITE (6,6200) KDIM4, KDIM4                               21870
 6200         FORMAT (///1X, '*** ERROR:  MORE THAN',I5,' EVENT',       21880
     +         ' LABELS FOUND IN DICTIONARY'/16X, 'FOR DICTIONARIES',   21890
     +         ' WITH MORE THAN',I5, ' NAMES,',/16X, 'PLEASE USE',      21900
     +         ' A LARGER VERSION OF RASC')                             21910
              WRITE (6,6250)                                            21920
 6250         FORMAT (///' **** EXECUTION TERMINATED IN',               21930
     +          '   SUBROUTINE READIN')                                 21940
              STOP                                                      21950
 7000 N = I - 1                                                         21960
      WRITE (6,7500) N                                                  21970
 7500 FORMAT (/1X, 'DICTIONARY:', I5, ' NAMES WERE READ IN.')           21980
C                                                                       21990
C  CHECK THE WELL DATA                                                  22000
C                                                                       22010
      IERR = 0                                                          22020
      IERR2 = 0                                                         22030
      DO 9000 I = 1,NS                                                  22040
          DO 8300 J = 1,N                                               22050
              ITALLY(J) = 0                                             22060
 8300     CONTINUE                                                      22070
          DO 8500 J = 1,KDIM3                                           22080
              ID = IABS (TMAT(I,J))                                     22090
              IF (ID.EQ.0)  GO TO 9000                                  22100
              IF (ID.GT.N)  GO TO 8370                                  22110
              IF (ITALLY(ID).EQ.0)  GO TO 8400                          22120
                  WRITE (6,8340) (NAME(I,K), K = 1,5), ID               22130
 8340             FORMAT (/' IN ',5A4,' FOSSIL',I5,' OCCURS MORE THAN', 22140
     +              ' ONCE')                                            22150
                  IERR = IERR + 1                                       22160
                  GO TO 8500                                            22170
 8370         WRITE (6,8380) (NAME(I,K), K = 1,5), ID                   22180
 8380             FORMAT (/' IN ',5A4,' FOSSIL',I5,                     22190
     +              '  -  EXCEEDS LIMIT OF YOUR DICTIONARY')            22200
                  IERR2 = IERR2 + 1                                     22210
                  GO TO 8500                                            22220
 8400         ITALLY(ID) = 1                                            22230
 8500     CONTINUE                                                      22240
 9000 CONTINUE                                                          22250
      IF (IERR.EQ.0)  GO TO 9200                                        22260
          WRITE (6,9100) IERR                                           22270
 9100     FORMAT (//' *** ERROR -  ON',I6,' OCCASION(S), AN EVENT',     22280
     +      ' OCCURRED MORE THAN ONCE IN THE SAME WELL.'/15X, 'YOU',    22290
     +      ' MAY NOT REPORT MORE THAN ONE OCCURRENCE OF ANY FOSSIL',   22300
     +      ' IN ANY WELL.')                                            22310
 9200 IF (IERR2 .EQ. 0) GO TO 9300                                      22320
          WRITE (6,9220) IERR2, N                                       22330
 9220     FORMAT (//' *** ERROR - ON',I6,' OCCASION(S), THERE',         22340
     +      ' WAS A FOSSIL NUMBER GREATER THAN THE LARGEST',            22350
     +      ' DICTIONARY NUMBER:',I5)                                   22360
C                                                                       22370
C  PRINT ORIGINAL SEQUENCE DATA                                         22380
                                                                        22390
 9300 DO 9340 I = 1,NS                                                  22400
          DO 9320 J = 1,KDIM3                                           22410
              IX(I,J) = TMAT(I,J)                                       22420
 9320     CONTINUE                                                      22430
 9340 CONTINUE                                                          22440
      WRITE (6,9390)                                                    22450
 9390 FORMAT (///'   ORIGINAL SEQUENCE DATA')                           22460
      CALL ECHO                                                         22470
C                                                                       22480
      IF (IERR.EQ.0 .AND. IERR2.EQ.0)  GO TO 9400                       22490
          WRITE (6,6250)                                                22500
          STOP                                                          22510
C                                                                       22520
 9400 RETURN                                                            22530
      END                                                               22540
      SUBROUTINE REORD (AAA,IPOS)                                       22550
C                                                                       22560
C ... SUBROUTINE TO REORDER THE CUMULATIVE ORDER MATRIX DURING THE      22570
C  FINAL REORDERING OPTION                                              22580
C                                                                       22590
C  CALLED IN MAIN PROGRAMME.                                            22600
C                                                                       22610
      PARAMETER (KDIM1=25, KDIM3=120, KDIM4=280, KDIM5=10, KDIM6=145)   22620
      COMMON  N, NS,MMAX, IX(KDIM1,KDIM3), ICODE(KDIM4), IRCODE(KDIM4), 22630
     +        C(KDIM6,KDIM6)                                            22640
      INTEGER IPOS(KDIM6)                                               22650
      DATA  BOUND/3.0/, TAILL/0.05/, TAILR/0.95/                        22660
C                                                                       22670
C  RECOMPUTE FREQUENCIES FROM "Z" VALUES                                22680
C                                                                       22690
      DO 50 I = 1,MMAX                                                  22700
          K = I + 1                                                     22710
          DO 40 J = K,MMAX                                              22720
              ZED = C(I,J)                                              22730
              IF (ZED.GE.BOUND) GO TO 10                                22740
                  IF (ZED.EQ.AAA) GO TO 20                              22750
                  IF (ZED.EQ.-AAA) GO TO 30                             22760
                  CALL ZTOF (ZED,FREQ)                                  22770
                  C(I,J) = C(J,I) * FREQ / (1.0 - FREQ)                 22780
                  GO TO 40                                              22790
   10         CONTINUE                                                  22800
                  C(I,J) = 0.0                                          22810
                  C(J,I) = 0.0                                          22820
                  GO TO 40                                              22830
   20         CONTINUE                                                  22840
                  C(I,J) = C(J,I) / TAILL                               22850
                  C(J,I) = 0.0                                          22860
                  GO TO 40                                              22870
   30         CONTINUE                                                  22880
                  C(J,I) = C(J,I) / TAILR                               22890
                  C(I,J) = 0.0                                          22900
   40     CONTINUE                                                      22910
   50 CONTINUE                                                          22920
C                                                                       22930
C  REORDER THE FINAL RELATION MATRIX                                    22940
C                                                                       22950
      DO 120 I = 1,MMAX                                                 22960
          IFOS = IRCODE(I)                                              22970
          DO 60 L = 1,MMAX                                              22980
              IF (ICODE(L).EQ.IFOS) GO TO 70                            22990
   60     CONTINUE                                                      23000
   70     INEW = L                                                      23010
          DO 80 K = 1,MMAX                                              23020
              IAB = IPOS(K)                                             23030
              IF (IAB.EQ.INEW) GO TO 90                                 23040
   80     CONTINUE                                                      23050
   90     II2 = K                                                       23060
          IF (I.EQ.II2) GO TO 120                                       23070
          DO 100 L = 1,MMAX                                             23080
              TEMP = C(I,L)                                             23090
              C(I,L) = C(II2,L)                                         23100
              C(II2,L) = TEMP                                           23110
  100     CONTINUE                                                      23120
          ITEMP = IPOS(I)                                               23130
          IPOS(I) = IPOS(II2)                                           23140
          IPOS(II2) = ITEMP                                             23150
          DO 110 L = 1,MMAX                                             23160
              TEMP = C(L,I)                                             23170
              C(L,I) = C(L,II2)                                         23180
              C(L,II2) = TEMP                                           23190
  110     CONTINUE                                                      23200
  120 CONTINUE                                                          23210
      RETURN                                                            23220
      END                                                               23230
      SUBROUTINE SCATTR (IDATA, NST, IWELL)                             23240
C                                                                       23250
C ... SUBROUTINE TO PRODUCE A SCATTERGRAM FOR A GIVEN WELL              23260
C                                                                       23270
C  ACCEPTS:  IDATA  -  THE SEQUENCE DATA FOR THE SCATTERGRAM            23280
C            NST    -  NUMBER OF NON-ZERO ENTRIES IN THE SEQUENCE       23290
C            IWELL  -  THE WELL NUMBER                                  23300
C                                                                       23310
C  ADDED BY     M. HELLER CONSULTANTS                                   23320
C               HALIFAX, N.S.                                           23330
C                                                                       23340
C  CALLED IN MAIN PROGRAMME                                             23350
C                                                                       23360
      PARAMETER (KDIM1=25, KDIM3=120, KDIM4=280, KDIM5=10, KDIM6=145)   23370
      COMMON  N, NS,MMAX, IX(KDIM1,KDIM3), ICODE(KDIM4), IRCODE(KDIM4), 23380
     +        C(KDIM6,KDIM6)                                            23390
      INTEGER I, IEVENT, IFLAG, J, JLIMIT, LEVNUM, MAXCNT, NLEVS, NSAME,23400
     +        NSTP1, IDATA(KDIM3), ITABLE(30,20), NCOUNT(30)            23410
C                                                                       23420
C  MAXLEV  - MAXIMUM NUMBER OF LEVELS (NOT FOSSILS) IN THE WELL         23430
C  MAXSAM  - MAXIMUM NUMBER OF FOSSILS AT THE  *SAME*  LEVEL            23440
C  LEVNUM  - THE LEVEL NUMBER  (THAT WE ARE CURRENTLY EXAMINING)        23450
C                                                                       23460
      MAXLEV = 30                                                       23470
      MAXSAM = 20                                                       23480
      LEVNUM = 0                                                        23490
      NSTP1 = NST + 1                                                   23500
      IFLAG = 0                                                         23510
      J = 1                                                             23520
C                                                                       23530
C  MAIN LOOP:  EXAMINE THE ENTIRE SEQUENCE, ONE EVENT AT A TIME         23540
C                                                                       23550
      IEVENT = IDATA(J)                                                 23560
 2500 IF (IEVENT.EQ.0 .OR. J.GT.NSTP1 .OR. IFLAG.NE.0) GO TO 4000       23570
          J = J + 1                                                     23580
          IF (IEVENT.LT.0)  GO TO 3100                                  23590
C                                                                       23600
C             CASE:  POSITIVE EVENT-NUMBER (IMPLIES NEW LEVEL)          23610
C                   THIS IS ALWAYS THE CASE THE FIRST TIME THROUGH      23620
C                                                                       23630
              IF (LEVNUM.GT.0)  NCOUNT(LEVNUM) = NSAME                  23640
              LEVNUM = LEVNUM + 1                                       23650
              IF (LEVNUM.GT.MAXLEV)  GO TO 3000                         23660
                  NSAME = 1                                             23670
                  ITABLE(LEVNUM,1) = IEVENT                             23680
                  GO TO 3200                                            23690
C                                                                       23700
 3000         IFLAG = 1                                                 23710
                  GO TO 3200                                            23720
C                                                                       23730
C             CASE:  NEGATIVE EVENT NR. (THUS AT THE SAME LEVEL)        23740
C                                                                       23750
 3100         NSAME = NSAME + 1                                         23760
              IF (NSAME.GT.MAXSAM)  GO TO 3150                          23770
                  ITABLE(LEVNUM,NSAME) = -IEVENT                        23780
                  GO TO 3200                                            23790
C                                                                       23800
 3150         IFLAG = 2                                                 23810
                  GO TO 3200                                            23820
C                                                                       23830
 3200         IEVENT = IDATA(J)                                         23840
              GO TO 2500                                                23850
C             END-OF-MAIN-LOOP                                          23860
C                                                                       23870
 4000 NLEVS = LEVNUM                                                    23880
      IF (IEVENT.EQ.0 .AND. IFLAG.EQ.0)  GO TO 6000                     23890
C                                                                       23900
C             CASE:  EXIT CAUSED BY EXCEEDING A MAXIMUM                 23910
C                                                                       23920
              IF (IFLAG.EQ.2)  GO TO 4200                               23930
                  NLEVS = MAXLEV                                        23940
                  WRITE (6,4100) IWELL, MAXLEV                          23950
 4100             FORMAT (1X, '** SCATTERGRAM LIMITS EXCEEDED',         23960
     +             6X, 'AT WELL NUMBER', I4 /6X, 'MORE THAN',           23970
     +             I4, ' DISTINCT LEVELS')                              23980
                  GO TO 4500                                            23990
 4200         NSAME = MAXSAM                                            24000
                  WRITE (6,4300) IWELL, MAXSAM                          24010
 4300             FORMAT (1X, '** SCATTERGRAM LIMITS EXCEEDED',         24020
     +             6X, 'AT WELL NUMBER', I4 /6X, 'MORE THAN',           24030
     +             I4, ' COEVAL EVENTS')                                24040
 4500         NCOUNT(NLEVS) = NSAME                                     24050
              DO 4800 I = 1,NLEVS                                       24060
                  JLIMIT = NCOUNT(I)                                    24070
                  WRITE (6,4700) (ITABLE(I,J), J = 1,JLIMIT)            24080
 4700             FORMAT (1X, 10I4)                                     24090
 4800         CONTINUE                                                  24100
C                                                                       24110
C     ELSE  EXIT OCCURRED AT END OF SEQUENCE                            24120
C                                                                       24130
 6000 NCOUNT(NLEVS) = NSAME                                             24140
C                                                                       24150
C     NOW FIND THE MAXIMUM ON NCOUNT(I)                                 24160
C                                                                       24170
      MAXCNT = 0                                                        24180
      DO 6100 I = 1,NLEVS                                               24190
          IF (NCOUNT(I).GT.MAXCNT)  MAXCNT = NCOUNT(I)                  24200
 6100 CONTINUE                                                          24210
C                                                                       24220
      CALL SCDRAW (ITABLE,NLEVS,MAXCNT,NCOUNT)                          24230
C                                                                       24240
      RETURN                                                            24250
      END                                                               24260
      SUBROUTINE SCDRAW (ITABLE,NLEVS,MAXCNT,NCOUNT)                    24270
C                                                                       24280
C ... SUBROUTINE TO PRINT SCATTERGRAM FOR SUBROUTINE SCATTR             24290
C                                                                       24300
C  ADDED BY     M. HELLER CONSULTANTS                                   24310
C               HALIFAX, N.S.                                           24320
C                                                                       24330
C  THE MEMORY-TO-MEMORY "WRITE" STATEMENT IN LOOP 200 CONVERTS INTEGERS 24340
C  ("I" FORMAT) TO ALPHANUMERICS ("A" FORMAT)                           24350
C                                                                       24360
C  CALLED BY SUBROUTINE SCATTR                                          24370
C                                                                       24380
      PARAMETER (KDIM1=25, KDIM3=120, KDIM4=280, KDIM5=10, KDIM6=145)   24390
      COMMON  N, NS,MMAX, IX(KDIM1,KDIM3), ICODE(KDIM4), IRCODE(KDIM4), 24400
     +        C(KDIM6,KDIM6)                                            24410
      INTEGER ITABLE(30,20), NCOUNT(30)                                 24420
      CHARACTER*4  BLANK, DASH, MARK, COLOUT(30)                        24430
      DATA  MARK/' XX '/, BLANK/'    '/, DASH/'----'/                   24440
C                                                                       24450
      DO 100 I = 1,MAXCNT                                               24460
          LIMUP = MAXCNT + 1 - I                                        24470
          DO 200 J = 1,NLEVS                                            24480
              COLOUT(J) = BLANK                                         24490
              IF (NCOUNT(J).LT.LIMUP)  GO TO 200                        24500
              WRITE (COLOUT(J), '(I4)') ITABLE(J,LIMUP)                 24510
  200     CONTINUE                                                      24520
          WRITE (6,400) (COLOUT(J), J = 1,NLEVS)                        24530
  400     FORMAT (9X, 1HI, 30A4)                                        24540
  100 CONTINUE                                                          24550
      WRITE (6,500) (DASH,I = 1,NLEVS)                                  24560
  500 FORMAT (10H --------I,30A4)                                       24570
      DO 600 I = 1,MMAX                                                 24580
          DO 700 J = 1,NLEVS                                            24590
              COLOUT(J) = BLANK                                         24600
              KLIM = NCOUNT(J)                                          24610
              DO 800 K = 1,KLIM                                         24620
                  IF (IRCODE(I).EQ.ITABLE(J,K)) COLOUT(J) = MARK        24630
  800         CONTINUE                                                  24640
  700     CONTINUE                                                      24650
          WRITE (6,900) IRCODE(I), (COLOUT(J), J = 1,NLEVS)             24660
  900     FORMAT (3X, I5, ' I', 30A4)                                   24670
  600 CONTINUE                                                          24680
      RETURN                                                            24690
      END                                                               24700
      SUBROUTINE SCORE                                                  24710
C                                                                       24720
C ... SUBROUTINE TO CALCULATE STEP MODEL SCORES FOR INDIVIDUAL WELLS    24730
C                                                                       24740
C  CALLED IN MAIN PROGRAMME                                             24750
C                                                                       24760
      PARAMETER (KDIM1=25, KDIM3=120, KDIM4=280, KDIM5=10, KDIM6=145)   24770
      COMMON  N, NS,MMAX, IX(KDIM1,KDIM3), ICODE(KDIM4), IRCODE(KDIM4), 24780
     +        C(KDIM6,KDIM6)                                            24790
      COMMON /TEXT/ NAME(KDIM1,5), ITITLE(KDIM4,10)                     24800
      REAL    RSCORE(KDIM3,KDIM1)                                       24810
      CHARACTER*4  NAME, ITITLE                                         24820
C                                                                       24830
      DO 20 I = 1,MMAX                                                  24840
          DO 10 J = 1,NS                                                24850
              RSCORE(I,J) = 0.0                                         24860
   10     CONTINUE                                                      24870
   20 CONTINUE                                                          24880
C                                                                       24890
      DO 150 I = 1,NS                                                   24900
          DO 140 J = 1,MMAX                                             24910
              ID = IX(I,J)                                              24920
              IF (ID.EQ.0) GO TO 150                                    24930
              IAD = IABS (ID)                                           24940
              IELMT = ICODE(IAD)                                        24950
C                                                                       24960
              DO 30 K = 1,MMAX                                          24970
                  IF (IRCODE(K).EQ.IELMT) GO TO 40                      24980
   30         CONTINUE                                                  24990
   40         IOP = K                                                   25000
C                                                                       25010
              K = J                                                     25020
              IF (ID.LT.0) ITEST = 1                                    25030
   50         CONTINUE                                                  25040
                  K = K - 1                                             25050
                  IF (K.LT.1) GO TO 90                                  25060
                  ID2 = IX(I,K)                                         25070
                  IF (ITEST.EQ.1) GO TO 80                              25080
                  IAD2 = IABS (ID2)                                     25090
                  IELMT2 = ICODE(IAD2)                                  25100
                  DO 60 L = 1,MMAX                                      25110
                      IF (IRCODE(L).EQ.IELMT2) GO TO 70                 25120
   60             CONTINUE                                              25130
   70             IOP2 = L                                              25140
                  IF (IOP2.LT.IOP) GO TO 50                             25150
                  RSCORE(IOP,I) = RSCORE(IOP,I) + 1.0                   25160
                  GO TO 50                                              25170
   80             RSCORE(IOP,I) = RSCORE(IOP,I) + 0.5                   25180
                  IF (ID2.GT.0) ITEST = 0                               25190
                  GO TO 50                                              25200
C                                                                       25210
   90         K = J                                                     25220
              ITEST = 1                                                 25230
  100         K = K + 1                                                 25240
              IF (K.GT.KDIM3)  GO TO 140                                25250
              ID2 = IX(I,K)                                             25260
              IF (ID2.EQ.0) GO TO 140                                   25270
              IAD2 = IABS (ID2)                                         25280
              IELMT2 = ICODE(IAD2)                                      25290
              IF (ITEST.NE.1) GO TO 110                                 25300
              IF (ID2.LT.0) RSCORE(IOP,I) = RSCORE(IOP,I) + 0.5         25310
              IF (ID2.GT.0) ITEST = 0                                   25320
              IF (ID2.LT.0) GO TO 100                                   25330
  110         CONTINUE                                                  25340
              DO 120 L = 1,MMAX                                         25350
                  IF (IRCODE(L).EQ.IELMT2) GO TO 130                    25360
  120         CONTINUE                                                  25370
  130         IOP2 = L                                                  25380
              IF (IOP2.GT.IOP) GO TO 100                                25390
              RSCORE(IOP,I) = RSCORE(IOP,I) + 1.0                       25400
              GO TO 100                                                 25410
  140     CONTINUE                                                      25420
  150 CONTINUE                                                          25430
C                                                                       25440
      WRITE (6,1010)                                                    25450
 1010 FORMAT ('1', ' STEP MODEL',///11X, 'NAME', 24X,                   25460
     +  'NUMBER', 5X, 'WELL NUMBER')                                    25470
      WRITE (6,1030) (I, I = 1,NS)                                      25480
 1030 FORMAT (49X,17I5)                                                 25490
      WRITE (6,1040)                                                    25500
 1040 FORMAT (/)                                                        25510
      DO 160 I = 1,MMAX                                                 25520
          ID = IRCODE(I)                                                25530
          WRITE (6,1050) (ITITLE(ID,J), J = 1,10), ID                   25540
 1050     FORMAT (1X, 10A4, I3)                                         25550
          WRITE (6,1060) (RSCORE(I,K), K = 1,NS)                        25560
 1060     FORMAT ('+', 48X, 17F5.1 /)                                   25570
  160 CONTINUE                                                          25580
      RETURN                                                            25590
      END                                                               25600
      SUBROUTINE TAB1                                                   25610
C                                                                       25620
C ... SUBROUTINE TAB1 CONSTRUCTS AN OCCURRENCE TABLE SHOWING THE        25630
C  OCCURRENCE OF OPTIMUM SEQUENCE EVENTS IN EACH WELL                   25640
C                                                                       25650
C  CALLED IN MAIN PROGRAMME.                                            25660
C                                                                       25670
      PARAMETER (KDIM1=25, KDIM3=120, KDIM4=280, KDIM5=10, KDIM6=145)   25680
      COMMON  N, NS,MMAX, IX(KDIM1,KDIM3), ICODE(KDIM4), IRCODE(KDIM4), 25690
     +        C(KDIM6,KDIM6)                                            25700
      COMMON /TEXT/ NAME(KDIM1,5), ITITLE(KDIM4,10)                     25710
      CHARACTER*3  IBLANK, IEX, ITAB(KDIM6,KDIM1)                       25720
      CHARACTER*4  NAME, ITITLE                                         25730
      DATA    IBLANK/'   '/, IEX/'  X'/                                 25740
C                                                                       25750
C  MATRIX ITAB(KDIM6, KDIM1) IS THE OCCURRENCE TABLE                    25760
C                                                                       25770
      DO 20 I = 1,MMAX                                                  25780
          DO 10 J = 1,NS                                                25790
              ITAB(I,J) = IBLANK                                        25800
   10     CONTINUE                                                      25810
   20 CONTINUE                                                          25820
      DO 50 I = 1,NS                                                    25830
          DO 40 J = 1,KDIM3                                             25840
              IOC = IX(I,J)                                             25850
              IF (IOC.EQ.0) GO TO 50                                    25860
              IAD = IABS (IOC)                                          25870
              ID = ICODE(IAD)                                           25880
              DO 30 K = 1,MMAX                                          25890
                  IF (ID.NE.IRCODE(K)) GO TO 30                         25900
                  ITAB(K,I) = IEX                                       25910
                  GO TO 40                                              25920
   30         CONTINUE                                                  25930
   40     CONTINUE                                                      25940
   50 CONTINUE                                                          25950
      WRITE (6,6000)                                                    25960
 6000 FORMAT ('1', '  OCCURRENCE TABLE'//)                              25970
      WRITE (6,2000)                                                    25980
 2000 FORMAT (11X, 'NAME', 29X, 'NUMBER', 5X, 'WELL NUMBER')            25990
      WRITE (6,3000) (I, I = 1,NS)                                      26000
 3000 FORMAT (55X,25I3)                                                 26010
      WRITE (6,4000)                                                    26020
 4000 FORMAT (' '/)                                                     26030
      DO 60 I = 1,MMAX                                                  26040
          ID = IRCODE(I)                                                26050
          WRITE (6,5000) (ITITLE(ID,J), J = 1,10), ID                   26060
 5000     FORMAT (' ', 1X,10A4,I8)                                      26070
          WRITE (6,5001) (ITAB(I,K), K = 1,NS)                          26080
 5001     FORMAT ('+',54X,25A3, 5(/1X,54X,25A3))                        26090
   60 CONTINUE                                                          26100
      RETURN                                                            26110
      END                                                               26120
      SUBROUTINE WDIST (JIRCOD,QDAR,MPAIR,AAA,LLL,INEG,CRIT2)           26130
C                                                                       26140
C ... SUBROUTINE TO CALCULATE INTER-EVENT 'DISTANCES' FOR               26150
C  WEIGHTED DIFFERENCES                                                 26160
C                                                                       26170
C  ACCEPTS:   MPAIR  - AS GENERATED BY DIST()                           26180
C             JIRCOD - A COPY OF THE OPTIMUM SEQUENCE (ORIGINAL CODE    26190
C                      NUMBERS) OBTAINED BY THE PREVIOUS SCALED SOLU-   26200
C                      TION FROM THE MAIN PROGRAMME.                    26210
C                    THE FIRST TIME THROUGH, JIRCOD WILL CONTAIN A      26220
C                      COPY OF THE OPTIMUM SEQUENCE FROM THE RANKING    26230
C                      SOLUTION.                                        26240
C             IUNIQ(*,2)  -  A MAP SHOWING THE UNIQUE EVENTS IN COLUMN  26250
C                      1 OF IUNIQ AND THE MARKER HORIZONS IN COLUMN 2.  26260
C                                                                       26270
C  RETURNS:   QDAR   - FOR ORDER()                                      26280
C             IRCODE - ANOTHER COPY OF THE OPTIMUM SEQUENCE OBTAINED    26290
C                      IN THE PREVIOUS ITERATION.  (THIS COPY IS SENT   26300
C                      TO ORDER().)                                     26310
C                                                                       26320
C  CALLED IN MAIN PROGRAMME.                                            26330
C                                                                       26340
      PARAMETER (KDIM1=25, KDIM3=120, KDIM4=280, KDIM5=10, KDIM6=145)   26350
      PARAMETER (MAXCYC=300, MAXUQ=20)                                  26360
      COMMON N, NS,MMAX, IX(KDIM1,KDIM3), ICODE(KDIM4), IRCODE(KDIM4),  26370
     +       C(KDIM6,KDIM6)                                             26380
      COMMON /BETA/ IUNIQ(KDIM4,2), NUNIQ(KDIM1), MUNIQ(KDIM1,MAXUQ*2)  26390
      DIMENSION JIRCOD(KDIM4), MPAIR(KDIM6+MAXUQ), QDAR(KDIM6+MAXUQ)    26400
      DATA  PI/3.141592654/, CONST3/-111.1111/, CONST4/999.9999/        26410
C                                                                       26420
      QDAR(1) = 0.0                                                     26430
      NMAX = MMAX - 1                                                   26440
      IF (LLL.EQ.0) GO TO 10                                            26450
      WRITE (6,1010)                                                    26460
 1010 FORMAT (' DISTANC                   26450
      WRITE (6,1010)                                                    26460
 1010 FORMAT ('1DISTANCE ANALYSIS REPEATED WITH WEIGHTED DIFFERENCES'//)26470
      WRITE (6,1020)                                                    26480
 1020 FORMAT (1X, 'POSITION   FOSSIL     FOSSIL     CUMULATIVE',        26490
     + 5X, 'SUM DIFF WEIGHT     S.D.' /12X, 'PAIRS     DISTANCE',       26500
     + '     DISTANCE', 6X, 'Z VALUES'/)                                26510
   10 DO 20 I = 1,MMAX                                                  26520
          IRCODE(I) = JIRCOD(I)                                         26530
   20 CONTINUE                                                          26540
C                                                                       26550
C  IT IS STILL ASSUMED THAT  C(I1,I2)  IS A "Z"-VALUE                   26560
C  WHENEVER  I1 .LT. I2                                                 26570
C                                                                       26580
      DO 190 I = 1,NMAX                                                 26590
          RCONT = 0.0                                                   26600
          RCONT2 = 0.0                                                  26610
          SDIFF = 0.0                                                   26620
          SDIF2 = 0.0                                                   26630
          ISTP = 0                                                      26640
          MARK2 = IRCODE(I)                                             26650
          MARK3 = IRCODE(I+1)                                           26660
C                                                                       26670
C  CASE:  K .LT. I                                                      26680
C         SAME ROW, DIFFERENT COLUMN                                    26690
C                                                                       26700
          K = I - 1                                                     26710
   30     IF (K.EQ.0) GO TO 70                                          26720
              RCOL1 = C(K,I)                                            26730
              RCOL2 = C(K,I+1)                                          26740
C                                                                       26750
C         RCOL1, RCOL2  -  TEMPORARY VARIABLES                          26760
C                                                                       26770
              MARK1 = IRCODE(K)                                         26780
              MARKER = 0                                                26790
              MARKA = 0                                                 26800
              IF (IUNIQ(MARK1,2).EQ.1) MARKER = 1                       26810
              IF (IUNIQ(MARK2,2).EQ.1 .OR. IUNIQ(MARK3,2).EQ.1)         26820
     +            MARKA = 1                                             26830
              IF (MARKER.EQ.1 .AND. MARKA.EQ.1) GO TO 60                26840
              IF (RCOL1.LT.-3.0 .OR. RCOL1.GT.3.0) GO TO 60             26850
              IF (RCOL2.LT.-3.0 .OR. RCOL2.GT.3.0) GO TO 60             26860
              QRCOL1 = RCOL1                                            26870
              CALL ZTOF (QRCOL1,P)                                      26880
              RFAC = 1.0                                                26890
              IF (MARKER.EQ.1 .OR. IUNIQ(MARK2,2).EQ.1) RFAC = 0.5      26900
              W1 = (C(I,K) / (1.-P)) * EXP (-RCOL1**2) / RFAC           26910
              W1 = W1 / (2.0 * PI * P * (1.-P))                         26920
              RCOL1 = RCOL1 * SQRT (RFAC)                               26930
              QRCOL2 = RCOL2                                            26940
              CALL ZTOF (QRCOL2,P)                                      26950
              RFAC = 1.0                                                26960
              IF (IUNIQ(MARK3,2).EQ.1 .OR. MARKER.EQ.1) RFAC = 0.5      26970
              W2 = (C(I+1,K) / (1.-P)) * EXP (-RCOL2**2) / RFAC         26980
              W2 = W2 / (2.0 * PI * P * (1.-P))                         26990
              RCOL2 = RCOL2 * SQRT (RFAC)                               27000
              WW = (W1 * W2) / (W1 + W2)                                27010
              RCONT = RCONT + WW                                        27020
              RDIFF = (RCOL2 - RCOL1) * WW                              27030
              RDIF2 = ((RCOL2 - RCOL1) ** 2) * WW                       27040
              IF (RCOL1.EQ.AAA .AND. RDIFF.EQ.0.0) GO TO 40             27050
                  GO TO 50                                              27060
   40         ISTP = ISTP + 1                                           27070
              RCONT2 = RCONT2 + ((W1*W2) / (W1+W2))                     27080
   50         IF (RCOL1.NE.AAA .OR. RCOL2.NE.AAA) ISTP = 0              27090
              IF (RCOL1.NE.AAA .OR. RCOL2.NE.AAA) RCONT2 = 0.0          27100
              IF (ISTP.EQ.5) RCONT = RCONT - RCONT2                     27110
              IF (ISTP.EQ.5) GO TO 70                                   27120
              SDIFF = SDIFF + RDIFF                                     27130
              SDIF2 = SDIF2 + RDIF2                                     27140
   60         K = K - 1                                                 27150
              GO TO 30                                                  27160
C                                                                       27170
C  CASE:  K .EQ. I                                                      27180
C                                                                       27190
   70     IF (ISTP.GT.0 .AND. ISTP.LT.5) RCONT = RCONT - RCONT2         27200
          CAA = C(I,I+1)                                                27210
          IF(IUNIQ(MARK2,2).EQ.1.AND.IUNIQ(MARK3,2).EQ.1) WRITE (6,1040)27220
 1040     FORMAT (/1X, '** WARNING-  ADJOINING MARKER HORIZONS'//)      27230
          IF (CAA.GE.-AAA .AND. CAA.LE.AAA) GO TO 80                    27240
              GO TO 90                                                  27250
   80     QCAA = CAA                                                    27260
          CALL ZTOF (QCAA,P)                                            27270
          W1 = (C(I+1,I) * EXP (-CAA**2)) / (2.0 * PI * P * (1.-P)**2)  27280
          RFAC = 1.0                                                    27290
          IF (IUNIQ(MARK3,2).EQ.1) RFAC = 0.5                           27300
          RCONT = RCONT + W1 / RFAC                                     27310
          SDIFF = SDIFF + (W1 * CAA * SQRT (RFAC))                      27320
          SDIF2 = SDIF2 + (W1 * (CAA * RFAC)**2)                        27330
   90     ISTP = 0                                                      27340
          RCONT2 = 0.0                                                  27350
          K = I+2                                                       27360
  100     IF (K.GT.MMAX) GO TO 140                                      27370
C                                                                       27380
C      CASE:  K .GT. I                                                  27390
C             DIFFERENT ROW, SAME COLUMN                                27400
C                                                                       27410
              RCOL1 = C(I,K)                                            27420
              RCOL2 = C(I+1,K)                                          27430
              MARK1 = IRCODE(K)                                         27440
              MARKER = 0                                                27450
              IF (IUNIQ(MARK1,2).EQ.1) MARKER = 1                       27460
              IF (MARKER.EQ.1 .AND. MARKA.EQ.1) GO TO 130               27470
              IF (RCOL1.LT.-3.0 .OR. RCOL1.GT.3.0) GO TO 130            27480
              IF (RCOL2.LT.-3.0 .OR. RCOL2.GT.3.0) GO TO 130            27490
              QRCOL1 = RCOL1                                            27500
              CALL ZTOF (QRCOL1,P)                                      27510
C                                                                       27520
C           SET RFAC FOR "W1";  THEN AGAIN FOR "W2"                     27530
C                                                                       27540
              RFAC = 1.0                                                27550
              IF (MARKER.EQ.1 .OR. IUNIQ(MARK2,2).EQ.1) RFAC = 0.5      27560
              W1 = (C(K,I) / (1.-P)) * EXP (-RCOL1**2) / RFAC           27570
              W1 = W1 / (2.0 * PI * P * (1.-P))                         27580
              RCOL1 = RCOL1 * SQRT (RFAC)                               27590
              QRCOL2 = RCOL2                                            27600
              CALL ZTOF (QRCOL2,P)                                      27610
              RFAC = 1.0                                                27620
              IF (IUNIQ(MARK3,2).EQ.1 .OR. MARKER.EQ.1) RFAC = 0.5      27630
              W2 = (C(K,I+1) / (1.-P)) * EXP (-RCOL2**2) / RFAC         27640
              W2 = W2 / (2.0 * PI * P * (1.-P))                         27650
              RCOL2 = RCOL2 * SQRT (RFAC)                               27660
              WW = (W1 * W2) / (W1 + W2)                                27670
              RCONT = RCONT+WW                                          27680
              RDIFF = (RCOL1 - RCOL2) * WW                              27690
              RDIF2 = (RCOL1 - RCOL2)**2 * WW                           27700
              IF (RCOL1.EQ.AAA .AND. RDIFF.EQ.0.0) GO TO 110            27710
                  GO TO 120                                             27720
  110         ISTP = ISTP + 1                                           27730
              RCONT2 = RCONT2 + ((W1*W2) / (W1+W2))                     27740
  120         IF (RCOL1.NE.AAA .OR. RCOL2.NE.AAA) ISTP = 0              27750
              IF (RCOL1.NE.AAA .OR. RCOL2.NE.AAA) RCONT2 = 0.0          27760
              IF (ISTP.EQ.5) RCONT = RCONT - RCONT2                     27770
              IF (ISTP.EQ.5) GO TO 140                                  27780
              SDIFF = SDIFF + RDIFF                                     27790
              SDIF2 = SDIF2 + RDIF2                                     27800
  130         K = K + 1                                                 27810
              GO TO 100                                                 27820
  140     IF (ISTP.GT.0 .AND. ISTP.LT.5) RCONT = RCONT - RCONT2         27830
C                                                                       27840
C         SET QDIFF, VARX, STDDEV, RDENO                                27850
C                                                                       27860
          QDIFF = 0.0                                                   27870
          IF (RCONT.NE.0.0)  QDIFF = SDIFF / RCONT                      27880
          RDENO = (MPAIR(I) - 1) * RCONT                                27890
          VARX = 0.0                                                    27900
          IF (RDENO.NE.0.0)  VARX = (-QDIFF*QDIFF*RCONT + SDIF2) / RDENO27910
          STDDEV = CONST3                                               27920
          IF (VARX.GE.0.0)  STDDEV = SQRT (VARX)                        27930
          IF (RDENO.EQ.0.0 .OR. MPAIR(I).EQ.1)  STDDEV = CONST4         27940
C                                                                       27950
          IF (INEG.NE.1)  GO TO 182                                     27960
              IF (STDDEV.EQ.CONST4 .OR. STDDEV.EQ.CONST3)  QDIFF = 0.0  27970
              IF (FLOAT (MPAIR(I)).LT.CRIT2)  QDIFF = 0.0               27980
  182     QDAR(I+1) = QDAR(I) + QDIFF                                   27990
          IF (LLL.NE.0)  WRITE (6,2000) I, IRCODE(I), IRCODE(I+1),      28000
     +     QDIFF, QDAR(I+1), SDIFF, RCONT, STDDEV                       28010
 2000     FORMAT (1X, I8, I5, '-', I3, F11.4, F13.4, F14.4, F7.1, F10.4)28020
  190 CONTINUE                                                          28030
      RETURN                                                            28040
      END                                                               28050
      SUBROUTINE XUNIQ1 (I,IX1)                                         28060
C                                                                       28070
C ... SUBROUTINE XUNIQ1 IS USED WITH SUBROUTINE HPFILT TO CONSTRUCT     28080
C  A MATRIX OF POSITION REFERENCES FOR ALL SELECTED UNIQUE EVENTS.      28090
C  THIS MATRIX IS USED BY SUBROUTINE XUNIQ2 TO PLACE UNIQUE             28100
C  EVENTS INTO THE FINAL SEQUENCE.                                      28110
C                                                                       28120
C  ACCEPTS:  I     - THE WELL NUMBER FOR "NUNIQ"                        28130
C            IX1   - THE ORIGINAL (UNFILTERED) SEQUENCE DATA            28140
C  RETURNS:  MUNIQ - ROWS OF ORDERED PAIRS (SEE BELOW)                  28150
C                                                                       28160
C  HERE, "IX2" SHOULD CONTAIN THE FILTERED SEQUENCE DATA                28170
C            (FILTERED BUT NOT RECODED)                                 28180
C                                                                       28190
C  CALLED BY SUBROUTINE HPFILT.                                         28200
C                                                                       28210
      PARAMETER (KDIM1=25, KDIM3=120, KDIM4=280, KDIM5=10, KDIM6=145)   28220
      PARAMETER (MAXCYC=300, MAXUQ=20)                                  28230
      COMMON  N, NS, MMAX, IX2(KDIM1,KDIM3), MM(KDIM4), M(KDIM4),       28240
     +        RMAT(KDIM6,KDIM6)                                         28250
      COMMON /BETA/ IUNIQ(KDIM4,2), NUNIQ(KDIM1), MUNIQ(KDIM1,MAXUQ*2)  28260
      INTEGER IX1(KDIM1,KDIM3), IFIL(KDIM4), NOTFIL(KDIM4)              28270
C                                                                       28280
C  MUNIQ(KDIM1, 2 * MAX.NR.OF UNIQUE EVENTS) -                          28290
C      ROW NUMBER REFLECTS WELL NUMBER.                                 28300
C      ORDERED PAIR:  FIRST ELEMENT IS ORIGINAL CODE NR. OF UQ. EVT.    28310
C                     SECOND ELEMENT IS LOWEST NUMBERED NEIGHBOUR       28320
C                       AT THE SAME LEVEL OR A NEARBY LEVEL.            28330
C                       (SEE BODY OF ROUTINE FOR DETAILS)               28340
C                                                                       28350
C  IFIL(KDIM4)   - VECTOR OF LEVEL NUMBERS FOR THE FILTERED SEQUENCE    28360
C  NOTFIL(KDIM4) - VECTOR OF LEVEL NUMBERS FOR THE UNFILTERED SEQ.      28370
C                                                                       28380
      DO 10 J = 1,N                                                     28390
          IFIL(J) = 0                                                   28400
          NOTFIL(J) = 0                                                 28410
   10 CONTINUE                                                          28420
C                                                                       28430
C     ASSIGNMENT OF LEVEL NUMBERS, STARTING AT "1" AND INCREASING       28440
C         BY 1, PANNING LEFT-TO-RIGHT IN THE GIVEN SEQUENCE.            28450
C                                                                       28460
C     KK = LEVEL NUMBER                                                 28470
      KK = 0                                                            28480
      DO 30 J = 1,KDIM3                                                 28490
          ID = IX1(I,J)                                                 28500
          IF (ID.EQ.0) GO TO 40                                         28510
          IF (ID.LT.0) GO TO 20                                         28520
          KK = KK + 1                                                   28530
   20     NOTFIL(IABS (ID)) = KK                                        28540
   30 CONTINUE                                                          28550
   40 MAXTET = KK                                                       28560
      KK = 0                                                            28570
      DO 60 J = 1,KDIM3                                                 28580
          ID = IX2(I,J)                                                 28590
          IF (ID.EQ.0) GO TO 70                                         28600
          IF (ID.LT.0) GO TO 50                                         28610
          KK = KK + 1                                                   28620
   50     IFIL(IABS (ID)) = KK                                          28630
   60 CONTINUE                                                          28640
   70 CONTINUE                                                          28650
      KKK = 1                                                           28660
      DO 120 J = 1,KDIM3                                                28670
C                                                                       28680
C         LOCATE NEXT UNIQUE EVENT;  SET "LEV1"                         28690
C                                                                       28700
          ID = IX1(I,J)                                                 28710
          IF (ID.EQ.0) GO TO 900                                        28720
          IDA = IABS (ID)                                               28730
          IF (IUNIQ(IDA,1).NE.1) GO TO 120                              28740
          LEV1 = NOTFIL(IDA)                                            28750
C                                                                       28760
          DO 80 JJ = 1,N                                                28770
C                                                                       28780
C             LOOK IN THE FILTERED SEQUENCE FOR A (NON-UNIQUE) EVENT    28790
C             ON THE  *SAME*  LEVEL.  (TAKE THE LOWEST NUMBERED FOSSIL) 28800
C                                                                       28810
              IF (NOTFIL(JJ).NE.LEV1) GO TO 80                          28820
              IF (IFIL(JJ).EQ.0) GO TO 80                               28830
              MUNIQ(I,KKK) = IDA                                        28840
              KKK = KKK + 1                                             28850
              MUNIQ(I,KKK) = -JJ                                        28860
              KKK = KKK + 1                                             28870
              GO TO 120                                                 28880
   80     CONTINUE                                                      28890
          ISTEP = LEV1                                                  28900
          ISTEM = LEV1                                                  28910
C                                                                       28920
C    ELSE LOOK FOR LOWEST NUMBERED FOSSIL AT AN  *ADJACENT*  LEVEL.     28930
C         FIRST TRY 1-BELOW, 1-ABOVE;                                   28940
C         THEN (IF NECESSARY)  2-BELOW, 2-ABOVE;   ... AND SO ON.       28950
C                                                                       28960
   90     ISTEP = ISTEP + 1                                             28970
          ISTEM = ISTEM - 1                                             28980
          DO 110 JJ = 1,N                                               28990
              IDSTP = NOTFIL(JJ)                                        29000
              IF (ISTEM.LE.0 .OR. IDSTP.NE.ISTEM) GO TO 100             29010
                  IF (IFIL(JJ).EQ.0) GO TO 100                          29020
                  MUNIQ(I,KKK) = -IDA                                   29030
                  KKK = KKK + 1                                         29040
                  MUNIQ(I,KKK) = JJ                                     29050
                  KKK = KKK + 1                                         29060
                  GO TO 120                                             29070
  100         IF (ISTEP.GT.MAXTET .OR. ISTEP.NE.IDSTP) GO TO 110        29080
                  IF (IFIL(JJ).EQ.0) GO TO 110                          29090
                  MUNIQ(I,KKK) = IDA                                    29100
                  KKK = KKK + 1                                         29110
                  MUNIQ(I,KKK) = JJ                                     29120
                  KKK = KKK + 1                                         29130
                  GO TO 120                                             29140
  110     CONTINUE                                                      29150
          IF (ISTEP.LE.MAXTET .OR. ISTEM.GT.0) GO TO 90                 29160
  120 CONTINUE                                                          29170
  900 RETURN                                                            29180
      END                                                               29190
      SUBROUTINE XUNIQ2 (N,II,ICNT,IVEC,RMAT,RUNIQ)                     29200
C                                                                       29210
C ... SUBROUTINE TO PLACE UNIQUE EVENTS IN FINAL SEQUENCE               29220
C                                                                       29230
C  POSITIONS OF UNIQUE EVENTS ARE DETERMINED FROM FIRST AND SECOND      29240
C  APPROXIMATIONS BASED ON POSITIONS OF NEIGHBOURING EVENTS.            29250
C                                                                       29260
C  ACCEPTS:  II    - THE WELL NUMBER                                    29270
C            IVEC(KDIM3)  - THE SEQUENCE DATA FOR THIS WELL,            29280
C                  RE-ORDERED ACCORDING TO THE OPTIMUM SEQUENCE         29290
C            ICNT  = (LENGTH OF THIS SEQUENCE) + 1                      29300
C            RMAT(KDIM3, 3)  - COL. 1:  CUMULATIVE DISTANCES;           29310
C                              COL. 2:  FIRST ORDER DIFFERENCES;        29320
C                              COL. 3:  SECOND ORDER DIFFERENCES        29330
C                                 SLIGHTLY TRANSFORMED IN COMP().       29340
C  RETURNS:  RUNIQ  -  COLUMN 1 SUMS UP ALL 'X2'S                       29350
C                      COLUMN 2 COUNTS HOW MANY 'X2'S THERE WERE        29360
C                                                                       29370
C  CALLED BY SUBROUTINE COMP.                                           29380
C                                                                       29390
      PARAMETER (KDIM1=25, KDIM3=120, KDIM4=280, KDIM5=10, KDIM6=145)   29400
      PARAMETER (MAXCYC=300, MAXUQ=20)                                  29410
      COMMON /BETA/ IUNIQ(KDIM4,2), NUNIQ(KDIM1), MUNIQ(KDIM1,MAXUQ*2)  29420
      INTEGER ILEV(KDIM4), IVEC(KDIM4)                                  29430
      REAL    RMAT(KDIM4,3), RUNIQ(KDIM4,2), RX(3,2)                    29440
      DATA    CONST5/1.386/                                             29450
C                                                                       29460
C  RX(3,2) -   THREE ORDERED PAIRS                                      29470
C      1:  (SUM OF CUM. DISTANCES;  COUNT OF CUM. DISTANCES)            29480
C      2:  (SUM OF 1ST-ORD. DIFFERENCES;  COUNT OF 1-O.D.)              29490
C      3:  (SUM OF 2ND-ORD. DIFFERENCES;  COUNT OF 2-O.D.)              29500
C                                                                       29510
      DO 10 I = 1,N                                                     29520
          ILEV(I) = 0                                                   29530
   10 CONTINUE                                                          29540
      KK = 0                                                            29550
      DO 30 I = 1,ICNT                                                  29560
          IF (IVEC(I).LT.0) GO TO 20                                    29570
          KK = KK + 1                                                   29580
   20     ILEV(I) = KK                                                  29590
   30 CONTINUE                                                          29600
      MAXTEP = KK                                                       29610
      ITEM = 1                                                          29620
C                                                                       29630
C  LOOP UNTIL NO MORE UNIQUE EVENTS                                     29640
C        (MAIN LOOP)                                                    29650
C                                                                       29660
   40 IEVENT = MUNIQ(II,ITEM)                                           29670
      IREFF = MUNIQ(II,ITEM+1)                                          29680
      IF (IEVENT.EQ.0) GO TO 999                                        29690
      DO 50 I = 1,N                                                     29700
          IF (IABS(IVEC(I)) .EQ. IABS(IREFF)) GO TO 60                  29710
   50 CONTINUE                                                          29720
   60 LEVEL = ILEV(I)                                                   29730
      IF (IREFF.GE.0) GO TO 70                                          29740
          LEV0 = LEVEL                                                  29750
          LEVM = LEV0 - 1                                               29760
          LEVP = LEV0 + 1                                               29770
          GO TO 90                                                      29780
   70 IF (IEVENT.GE.0) GO TO 80                                         29790
          LEVM = LEVEL                                                  29800
          LEVP = LEVEL + 1                                              29810
          LEV0 = 0                                                      29820
          GO TO 90                                                      29830
   80 LEV0 = 0                                                          29840
          LEVP = LEVEL                                                  29850
          LEVM = LEVEL - 1                                              29860
C                                                                       29870
C  CALCULATE THE FIRST APPROXIMATION, X1                                29880
C                                                                       29890
   90 DO 100 I = 1,3                                                    29900
          RX(I,1) = 0.0                                                 29910
          RX(I,2) = 0.0                                                 29920
  100 CONTINUE                                                          29930
      DO 130 I = 1,ICNT                                                 29940
          LEVI = ILEV(I)                                                29950
          IF (LEVM.LE.0) GO TO 110                                      29960
              IF (LEVM.NE.LEVI) GO TO 110                               29970
              RX(1,1) = RX(1,1) + RMAT(I,1)                             29980
              RX(1,2) = RX(1,2) + 1.0                                   29990
              GO TO 130                                                 30000
  110     IF (LEV0.EQ.0) GO TO 120                                      30010
              IF (LEV0.NE.LEVI) GO TO 120                               30020
              RX(2,1) = RX(2,1) + RMAT(I,1)                             30030
              RX(2,2) = RX(2,2) + 1.0                                   30040
              GO TO 130                                                 30050
  120     IF (LEVP.GT.MAXTEP) GO TO 130                                 30060
              IF (LEVP.NE.LEVI) GO TO 130                               30070
              RX(3,1) = RX(3,1) + RMAT(I,1)                             30080
              RX(3,2) = RX(3,2) + 1.0                                   30090
  130 CONTINUE                                                          30100
      RRR = 0.0                                                         30110
      ARX1 = 0.0                                                        30120
      ARX2 = 0.0                                                        30130
      ARX3 = 0.0                                                        30140
C                                                                       30150
C     COMPUTE AVERAGES                                                  30160
C                                                                       30170
      IF (RX(1,2).EQ.0.0) GO TO 140                                     30180
          ARX1 = RX(1,1) / RX(1,2)                                      30190
          RRR = RRR + 1.0                                               30200
  140 IF (RX(2,2).EQ.0.0) GO TO 150                                     30210
          ARX2 = RX(2,1) / RX(2,2)                                      30220
          RRR = RRR + 1.0                                               30230
  150 IF (RX(3,2).EQ.0.0) GO TO 160                                     30240
          ARX3 = RX(3,1) / RX(3,2)                                      30250
          RRR = RRR + 1.0                                               30260
  160 X1 = (ARX1 + ARX2 + ARX3) / RRR                                   30270
C                                                                       30280
C  CALCULATE THE SECOND APPROXIMATION,  X2                              30290
C                                                                       30300
      RANGE1 = X1 - CONST5                                              30310
      RANGE2 = X1 + CONST5                                              30320
      RSUM = 0.0                                                        30330
      RRR = 0.0                                                         30340
      DO 190 I = 1,ICNT                                                 30350
          DIST1 = RMAT(I,1)                                             30360
          IF (DIST1.LT.RANGE1 .OR. DIST1.GT.RANGE2) GO TO 190           30370
          IF (LEV0.EQ.0 .OR. LEVEL.NE.ILEV(I)) GO TO 170                30380
              RSUM = RSUM + DIST1                                       30390
              RRR = RRR + 1                                             30400
              GO TO 190                                                 30410
  170     IF (ILEV(I).LE.LEVM .AND. LEVM.GT.0) GO TO 180                30420
              IF (ILEV(I).LT.LEVP .OR. LEVP.GT.MAXTEP) GO TO 190        30430
              RSUM = RSUM + ((DIST1 + RANGE1) * 0.5)                    30440
              RRR = RRR + 1                                             30450
              GO TO 190                                                 30460
  180     RSUM = RSUM + ((DIST1 + RANGE2) * 0.5)                        30470
              RRR = RRR + 1                                             30480
  190 CONTINUE                                                          30490
      X2 = X1                                                           30500
      IF (RRR.NE.0.0)  X2 = RSUM / RRR                                  30510
      ID = IABS (IEVENT)                                                30520
      RUNIQ(ID,1) = RUNIQ(ID,1) + X2                                    30530
      RUNIQ(ID,2) = RUNIQ(ID,2) + 1.0                                   30540
      ITEM = ITEM + 2                                                   30550
      GO TO 40                                                          30560
C                                                                       30570
  999 RETURN                                                            30580
      END                                                               30590
      SUBROUTINE ZTOF (Z,PZ)                                            30600
C                                                                       30610
C ... SUBROUTINE TO COMPUTE FREQUENCY FROM Z.   EQ. 26.2.17   IN        30620
C                                                                       30630
C      ABRAMOWITZ, M. AND STEGUN, I.A.     (EDITORS)                    30640
C      "HANDBOOK OF MATHEMATICAL FUNCTIONS                              30650
C         WITH FORMULAS, GRAPHS, AND MATHEMATICAL TABLES"               30660
C      PUB. BY NATIONAL BUREAU OF STANDARDS OF THE                      30670
C         U.S. DEPARTMENT OF COMMERCE,   1964.                          30680
C                                                                       30690
C  CALLED BY SUBROUTINES  COMP, REORD, & WDIST                          30700
C                                                                       30710
      DATA  PI/3.141592654/, CONST6/0.2316419/, B1/0.319381530/,        30720
     +      B2/-0.356563782/, B3/1.781477937/, B4/-1.821255978/,        30730
     +      B5/1.330274429/                                             30740
C                                                                       30750
      X = Z                                                             30760
      IF (Z.LT.0.0) X = -Z                                              30770
      T = 1.0 / (CONST6 * X + 1.0)                                      30780
      PID = 2.0 * PI                                                    30790
      XX = -X * X / 2.0                                                 30800
      XX = EXP (XX) / SQRT (PID)                                        30810
      PZ = (B1 * T) + (B2 * T * T) + (B3 * T**3) + (B4 * T**4) +        30820
     +     (B5 * T**5)                                                  30830
      PZ = 1.0 - (PZ * XX)                                              30840
      IF (Z.LT.0.0) PZ = 1.0 - PZ                                       30850
      RETURN                                                            30860
      END                                                               30870
